#include <ctype.h>  /* NOLINT */
#include <stdio.h>  /* NOLINT */
#include <stdlib.h> /* NOLINT */
#include <string.h> /* NOLINT */
#include <time.h>   /* NOLINT */

#if defined(_MSC_VER)
#pragma warning(disable : 4996) /* deprecation */
#endif



/* Forward declare test functions. */
int mqtt_packet_puback(int, char*[]);
int mqtt_packet_pubrec(int, char*[]);
int mqtt_packet_pubrel(int, char*[]);
int mqtt_packet_pubcomp(int, char*[]);
int mqtt_packet_suback(int, char*[]);
int mqtt_packet_unsuback(int, char*[]);
int mqtt_packet_connect(int, char*[]);
int mqtt_packet_connect_will(int, char*[]);
int mqtt_packet_connect_empty_payload_will(int, char*[]);
int mqtt_packet_connect_password(int, char*[]);
int mqtt_packet_connect_all(int, char*[]);
int mqtt_packet_connack(int, char*[]);
int mqtt_packet_publish_qos0_dup(int, char*[]);
int mqtt_packet_publish_qos2_retain(int, char*[]);
int mqtt_packet_publish_empty_payload(int, char*[]);
int mqtt_packet_subscribe(int, char*[]);
int mqtt_packet_unsubscribe(int, char*[]);
int mqtt_packet_pingreq(int, char*[]);
int mqtt_packet_pingresp(int, char*[]);
int mqtt_packet_disconnect(int, char*[]);
int mqtt_packet_connack_decode_failure_reserved(int, char*[]);
int mqtt_packet_ack_decode_failure_reserved(int, char*[]);
int mqtt_packet_pingresp_decode_failure_reserved(int, char*[]);
int mqtt_frame_and_decode_publish(int, char*[]);
int mqtt_frame_and_decode_suback(int, char*[]);
int mqtt_frame_and_decode_unsuback(int, char*[]);
int mqtt_frame_and_decode_puback(int, char*[]);
int mqtt_frame_and_decode_pingresp(int, char*[]);
int mqtt_frame_and_decode_connack(int, char*[]);
int mqtt_frame_and_decode_bad_remaining_length(int, char*[]);
int mqtt_frame_and_decode_unsupported_packet_type(int, char*[]);
int mqtt_frame_and_decode_bad_flags_for_packet_type(int, char*[]);
int mqtt_topic_tree_match(int, char*[]);
int mqtt_topic_tree_unsubscribe(int, char*[]);
int mqtt_topic_tree_duplicate_transactions(int, char*[]);
int mqtt_topic_tree_transactions(int, char*[]);
int mqtt_topic_validation(int, char*[]);
int mqtt_topic_filter_validation(int, char*[]);
int mqtt_connect_disconnect(int, char*[]);
int mqtt_connect_set_will_login(int, char*[]);
int mqtt_connection_interrupted(int, char*[]);
int mqtt_connection_any_publish(int, char*[]);
int mqtt_connection_timeout(int, char*[]);
int mqtt_connection_connack_timeout(int, char*[]);
int mqtt_connection_failure_callback(int, char*[]);
int mqtt_connection_success_callback(int, char*[]);
int mqtt_connect_subscribe(int, char*[]);
int mqtt_connect_subscribe_fail_from_broker(int, char*[]);
int mqtt_connect_subscribe_multi(int, char*[]);
int mqtt_connect_subscribe_incoming_dup(int, char*[]);
int mqtt_connect_unsubscribe(int, char*[]);
int mqtt_connect_resubscribe(int, char*[]);
int mqtt_connect_publish(int, char*[]);
int mqtt_connect_publish_payload(int, char*[]);
int mqtt_connection_offline_publish(int, char*[]);
int mqtt_connection_disconnect_while_reconnecting(int, char*[]);
int mqtt_connection_closes_while_making_requests(int, char*[]);
int mqtt_connection_resend_packets(int, char*[]);
int mqtt_connection_consistent_retry_policy(int, char*[]);
int mqtt_connection_not_resend_packets_on_healthy_connection(int, char*[]);
int mqtt_connection_destory_pending_requests(int, char*[]);
int mqtt_clean_session_not_retry(int, char*[]);
int mqtt_clean_session_discard_previous(int, char*[]);
int mqtt_clean_session_keep_next_session(int, char*[]);
int mqtt_connection_publish_QoS1_timeout(int, char*[]);
int mqtt_connection_publish_QoS1_timeout_override(int, char*[]);
int mqtt_connection_unsubscribe_timeout(int, char*[]);
int mqtt_connection_unsubscribe_timeout_override(int, char*[]);
int mqtt_connection_subscribe_single_timeout(int, char*[]);
int mqtt_connection_subscribe_single_timeout_override(int, char*[]);
int mqtt_connection_subscribe_multi_timeout(int, char*[]);
int mqtt_connection_resubscribe_timeout(int, char*[]);
int mqtt_connection_publish_QoS1_timeout_with_ping(int, char*[]);
int mqtt_connection_publish_QoS1_timeout_connection_lost_reset_time(int, char*[]);
int mqtt_connection_ping_norm(int, char*[]);
int mqtt_connection_ping_no(int, char*[]);
int mqtt_connection_ping_noack(int, char*[]);
int mqtt_connection_ping_basic_scenario(int, char*[]);
int mqtt_connection_ping_double_scenario(int, char*[]);
int mqtt_connection_close_callback_simple(int, char*[]);
int mqtt_connection_close_callback_interrupted(int, char*[]);
int mqtt_connection_close_callback_multi(int, char*[]);
int mqtt_connection_reconnection_backoff_stable(int, char*[]);
int mqtt_connection_reconnection_backoff_unstable(int, char*[]);
int mqtt_connection_reconnection_backoff_reset(int, char*[]);
int mqtt_connection_reconnection_backoff_reset_after_disconnection(int, char*[]);
int mqtt_validation_failure_publish_qos(int, char*[]);
int mqtt_validation_failure_invalid_will_qos(int, char*[]);
int mqtt_validation_failure_subscribe_empty(int, char*[]);
int mqtt_validation_failure_unsubscribe_null(int, char*[]);
int mqtt_validation_failure_connect_invalid_client_id_utf8(int, char*[]);
int mqtt_validation_failure_invalid_will_topic_utf8(int, char*[]);
int mqtt_validation_failure_invalid_username_utf8(int, char*[]);
int mqtt_operation_statistics_simple_publish(int, char*[]);
int mqtt_operation_statistics_offline_publish(int, char*[]);
int mqtt_operation_statistics_disconnect_publish(int, char*[]);
int mqtt_operation_statistics_reconnect_publish(int, char*[]);
int mqtt_operation_statistics_simple_subscribe(int, char*[]);
int mqtt_operation_statistics_simple_unsubscribe(int, char*[]);
int mqtt_operation_statistics_simple_resubscribe(int, char*[]);
int mqtt_operation_statistics_simple_callback(int, char*[]);
int mqtt_connection_termination_callback_simple(int, char*[]);
int mqtt5_topic_skip_rules_prefix(int, char*[]);
int mqtt5_topic_get_segment_count(int, char*[]);
int mqtt5_shared_subscription_validation(int, char*[]);
int mqtt_utf8_encoded_string_test(int, char*[]);
int mqtt5_inbound_topic_alias_register_failure(int, char*[]);
int mqtt5_inbound_topic_alias_resolve_success(int, char*[]);
int mqtt5_inbound_topic_alias_resolve_failure(int, char*[]);
int mqtt5_inbound_topic_alias_reset(int, char*[]);
int mqtt5_outbound_topic_alias_disabled_resolve_success(int, char*[]);
int mqtt5_outbound_topic_alias_disabled_resolve_failure(int, char*[]);
int mqtt5_outbound_topic_alias_manual_resolve_failure_zero_alias(int, char*[]);
int mqtt5_outbound_topic_alias_manual_resolve_failure_too_big_alias(int, char*[]);
int mqtt5_outbound_topic_alias_manual_resolve_success(int, char*[]);
int mqtt5_outbound_topic_alias_manual_reset(int, char*[]);
int mqtt5_outbound_topic_alias_lru_zero_size(int, char*[]);
int mqtt5_outbound_topic_alias_lru_a_ar(int, char*[]);
int mqtt5_outbound_topic_alias_lru_b_a_br(int, char*[]);
int mqtt5_outbound_topic_alias_lru_a_b_ar_br(int, char*[]);
int mqtt5_outbound_topic_alias_lru_a_b_c_br_cr_br_cr_a(int, char*[]);
int mqtt5_outbound_topic_alias_lru_a_b_c_a_cr_b(int, char*[]);
int mqtt5_outbound_topic_alias_lru_a_b_reset_a_b(int, char*[]);
int mqtt5_publish_operation_new_set_no_optional(int, char*[]);
int mqtt5_publish_operation_new_set_all(int, char*[]);
int mqtt5_publish_operation_new_failure_packet_id(int, char*[]);
int mqtt5_subscribe_operation_new_set_no_optional(int, char*[]);
int mqtt5_subscribe_operation_new_set_all(int, char*[]);
int mqtt5_unsubscribe_operation_new_set_all(int, char*[]);
int mqtt5_connect_storage_new_set_no_optional(int, char*[]);
int mqtt5_connect_storage_new_set_all(int, char*[]);
int mqtt5_connack_storage_new_set_no_optional(int, char*[]);
int mqtt5_connack_storage_new_set_all(int, char*[]);
int mqtt5_disconnect_storage_new_set_no_optional(int, char*[]);
int mqtt5_disconnect_storage_new_set_all(int, char*[]);
int mqtt5_suback_storage_new_set_no_optional(int, char*[]);
int mqtt5_suback_storage_new_set_all(int, char*[]);
int mqtt5_unsuback_storage_new_set_no_optional(int, char*[]);
int mqtt5_unsuback_storage_new_set_all(int, char*[]);
int mqtt5_puback_storage_new_set_all(int, char*[]);
int mqtt5_publish_storage_new_set_all(int, char*[]);
int mqtt5_operation_disconnect_validation_failure_server_reference(int, char*[]);
int mqtt5_operation_disconnect_validation_failure_bad_reason_code(int, char*[]);
int mqtt5_operation_disconnect_validation_failure_reason_string_too_long(int, char*[]);
int mqtt5_operation_disconnect_validation_failure_reason_string_invalid_utf8(int, char*[]);
int mqtt5_operation_disconnect_validation_failure_user_properties_name_too_long(int, char*[]);
int mqtt5_operation_disconnect_validation_failure_user_properties_name_invalid_utf8(int, char*[]);
int mqtt5_operation_disconnect_validation_failure_user_properties_value_too_long(int, char*[]);
int mqtt5_operation_disconnect_validation_failure_user_properties_value_invalid_utf8(int, char*[]);
int mqtt5_operation_disconnect_validation_failure_user_properties_too_many(int, char*[]);
int mqtt5_operation_connect_validation_failure_client_id_too_long(int, char*[]);
int mqtt5_operation_connect_validation_failure_client_id_invalid_utf8(int, char*[]);
int mqtt5_operation_connect_validation_failure_username_too_long(int, char*[]);
int mqtt5_operation_connect_validation_failure_username_invalid_utf8(int, char*[]);
int mqtt5_operation_connect_validation_failure_password_too_long(int, char*[]);
int mqtt5_operation_connect_validation_failure_receive_maximum_zero(int, char*[]);
int mqtt5_operation_connect_validation_failure_maximum_packet_size_zero(int, char*[]);
int mqtt5_operation_connect_validation_failure_will_invalid(int, char*[]);
int mqtt5_operation_connect_validation_failure_will_payload_too_long(int, char*[]);
int mqtt5_operation_connect_validation_failure_auth_method_unsupported(int, char*[]);
int mqtt5_operation_connect_validation_failure_auth_data_unsupported(int, char*[]);
int mqtt5_operation_connect_validation_failure_request_problem_information_invalid(int, char*[]);
int mqtt5_operation_connect_validation_failure_request_response_information_invalid(int, char*[]);
int mqtt5_operation_connect_validation_failure_user_properties_name_too_long(int, char*[]);
int mqtt5_operation_connect_validation_failure_user_properties_name_invalid_utf8(int, char*[]);
int mqtt5_operation_connect_validation_failure_user_properties_value_too_long(int, char*[]);
int mqtt5_operation_connect_validation_failure_user_properties_value_invalid_utf8(int, char*[]);
int mqtt5_operation_connect_validation_failure_user_properties_too_many(int, char*[]);
int mqtt5_operation_subscribe_validation_failure_no_subscriptions(int, char*[]);
int mqtt5_operation_subscribe_validation_failure_too_many_subscriptions(int, char*[]);
int mqtt5_operation_subscribe_validation_failure_invalid_subscription_identifier(int, char*[]);
int mqtt5_operation_subscribe_validation_failure_invalid_topic_filter(int, char*[]);
int mqtt5_operation_subscribe_validation_failure_invalid_utf8_topic_filter(int, char*[]);
int mqtt5_operation_subscribe_validation_failure_invalid_qos(int, char*[]);
int mqtt5_operation_subscribe_validation_failure_invalid_retain_type(int, char*[]);
int mqtt5_operation_subscribe_validation_failure_invalid_no_local(int, char*[]);
int mqtt5_operation_subscribe_validation_failure_user_properties_name_too_long(int, char*[]);
int mqtt5_operation_subscribe_validation_failure_user_properties_name_invalid_utf8(int, char*[]);
int mqtt5_operation_subscribe_validation_failure_user_properties_value_too_long(int, char*[]);
int mqtt5_operation_subscribe_validation_failure_user_properties_value_invalid_utf8(int, char*[]);
int mqtt5_operation_subscribe_validation_failure_user_properties_too_many(int, char*[]);
int mqtt5_operation_unsubscribe_validation_failure_no_topic_filters(int, char*[]);
int mqtt5_operation_unsubscribe_validation_failure_too_many_topic_filters(int, char*[]);
int mqtt5_operation_unsubscribe_validation_failure_invalid_topic_filter(int, char*[]);
int mqtt5_operation_unsubscribe_validation_failure_invalid_utf8_topic_filter(int, char*[]);
int mqtt5_operation_unsubscribe_validation_failure_user_properties_name_too_long(int, char*[]);
int mqtt5_operation_unsubscribe_validation_failure_user_properties_name_invalid_utf8(int, char*[]);
int mqtt5_operation_unsubscribe_validation_failure_user_properties_value_too_long(int, char*[]);
int mqtt5_operation_unsubscribe_validation_failure_user_properties_value_invalid_utf8(int, char*[]);
int mqtt5_operation_unsubscribe_validation_failure_user_properties_too_many(int, char*[]);
int mqtt5_operation_publish_validation_failure_invalid_topic(int, char*[]);
int mqtt5_operation_publish_validation_failure_invalid_utf8_topic(int, char*[]);
int mqtt5_operation_publish_validation_failure_no_topic(int, char*[]);
int mqtt5_operation_publish_validation_failure_invalid_payload_format(int, char*[]);
int mqtt5_operation_publish_validation_failure_invalid_utf8_payload(int, char*[]);
int mqtt5_operation_publish_validation_failure_response_topic_too_long(int, char*[]);
int mqtt5_operation_publish_validation_failure_invalid_response_topic(int, char*[]);
int mqtt5_operation_publish_validation_failure_invalid_utf8_response_topic(int, char*[]);
int mqtt5_operation_publish_validation_failure_correlation_data_too_long(int, char*[]);
int mqtt5_operation_publish_validation_failure_content_type_too_long(int, char*[]);
int mqtt5_operation_publish_validation_failure_invalid_utf8_content_type(int, char*[]);
int mqtt5_operation_publish_validation_failure_subscription_identifier_exists(int, char*[]);
int mqtt5_operation_publish_validation_failure_topic_alias_zero(int, char*[]);
int mqtt5_operation_publish_validation_failure_user_properties_name_too_long(int, char*[]);
int mqtt5_operation_publish_validation_failure_user_properties_name_invalid_utf8(int, char*[]);
int mqtt5_operation_publish_validation_failure_user_properties_value_too_long(int, char*[]);
int mqtt5_operation_publish_validation_failure_user_properties_value_invalid_utf8(int, char*[]);
int mqtt5_operation_publish_validation_failure_user_properties_too_many(int, char*[]);
int mqtt5_operation_publish_validation_failure_qos0_duplicate_true(int, char*[]);
int mqtt5_operation_publish_validation_failure_qos0_with_packet_id(int, char*[]);
int mqtt5_client_options_validation_failure_no_host(int, char*[]);
int mqtt5_client_options_validation_failure_no_bootstrap(int, char*[]);
int mqtt5_client_options_validation_failure_no_publish_received(int, char*[]);
int mqtt5_client_options_validation_failure_invalid_socket_options(int, char*[]);
int mqtt5_client_options_validation_failure_invalid_connect(int, char*[]);
int mqtt5_client_options_validation_failure_invalid_port(int, char*[]);
int mqtt5_operation_subscribe_connection_settings_validation_failure_exceeds_maximum_packet_size(int, char*[]);
int mqtt5_operation_unsubscribe_connection_settings_validation_failure_exceeds_maximum_packet_size(int, char*[]);
int mqtt5_operation_publish_connection_settings_validation_failure_exceeds_maximum_packet_size(int, char*[]);
int mqtt5_operation_publish_connection_settings_validation_failure_exceeds_maximum_qos(int, char*[]);
int mqtt5_operation_publish_connection_settings_validation_failure_invalid_retain(int, char*[]);
int mqtt5_operation_disconnect_connection_settings_validation_failure_exceeds_maximum_packet_size(int, char*[]);
int mqtt5_operation_disconnect_connection_settings_validation_failure_promote_zero_session_expiry(int, char*[]);
int mqtt5_client_options_defaults_set(int, char*[]);
int mqtt5_operation_bind_packet_id_empty_table(int, char*[]);
int mqtt5_operation_bind_packet_id_multiple_with_existing(int, char*[]);
int mqtt5_operation_bind_packet_id_multiple_with_wrap_around(int, char*[]);
int mqtt5_operation_bind_packet_id_full_table(int, char*[]);
int mqtt5_operation_bind_packet_id_not_valid(int, char*[]);
int mqtt5_operation_bind_packet_id_already_bound(int, char*[]);
int mqtt5_operation_processing_nothing_empty_queue(int, char*[]);
int mqtt5_operation_processing_nothing_mqtt_connect(int, char*[]);
int mqtt5_operation_processing_nothing_clean_disconnect(int, char*[]);
int mqtt5_operation_processing_nothing_pending_write_completion_mqtt_connect(int, char*[]);
int mqtt5_operation_processing_nothing_pending_write_completion_connected(int, char*[]);
int mqtt5_operation_processing_nothing_pending_write_completion_clean_disconnect(int, char*[]);
int mqtt5_operation_processing_failure_message_allocation(int, char*[]);
int mqtt5_operation_processing_failure_message_send(int, char*[]);
int mqtt5_operation_processing_something_mqtt_connect(int, char*[]);
int mqtt5_operation_processing_something_clean_disconnect(int, char*[]);
int mqtt5_operation_processing_something_connected_multi(int, char*[]);
int mqtt5_operation_processing_something_connected_overflow(int, char*[]);
int mqtt5_operation_processing_disconnect_fail_all(int, char*[]);
int mqtt5_operation_processing_disconnect_fail_qos0(int, char*[]);
int mqtt5_operation_processing_disconnect_fail_non_qos1(int, char*[]);
int mqtt5_operation_processing_reconnect_rejoin_session_fail_all(int, char*[]);
int mqtt5_operation_processing_reconnect_rejoin_session_fail_qos0(int, char*[]);
int mqtt5_operation_processing_reconnect_no_session_fail_all(int, char*[]);
int mqtt5_operation_processing_reconnect_no_session_fail_qos0(int, char*[]);
int mqtt5_operation_processing_reconnect_no_session_fail_non_qos1(int, char*[]);
int mqtt5_negotiated_settings_reset_test(int, char*[]);
int mqtt5_negotiated_settings_apply_connack_test(int, char*[]);
int mqtt5_negotiated_settings_server_override_test(int, char*[]);
int mqtt5_vli_size(int, char*[]);
int mqtt5_vli_success_round_trip(int, char*[]);
int mqtt5_vli_encode_failures(int, char*[]);
int mqtt5_vli_decode_failures(int, char*[]);
int mqtt5_packet_disconnect_round_trip(int, char*[]);
int mqtt5_packet_pingreq_round_trip(int, char*[]);
int mqtt5_packet_pingresp_round_trip(int, char*[]);
int mqtt5_packet_connect_round_trip(int, char*[]);
int mqtt5_packet_connack_round_trip(int, char*[]);
int mqtt5_packet_subscribe_round_trip(int, char*[]);
int mqtt5_packet_suback_round_trip(int, char*[]);
int mqtt5_packet_unsubscribe_round_trip(int, char*[]);
int mqtt5_packet_unsuback_round_trip(int, char*[]);
int mqtt5_packet_publish_round_trip(int, char*[]);
int mqtt5_packet_puback_round_trip(int, char*[]);
int mqtt5_packet_encode_connect_no_will(int, char*[]);
int mqtt5_packet_encode_connect_no_username(int, char*[]);
int mqtt5_packet_encode_connect_no_password(int, char*[]);
int mqtt5_packet_encode_connect_will_property_order(int, char*[]);
int mqtt5_first_byte_reserved_header_check_subscribe(int, char*[]);
int mqtt5_first_byte_reserved_header_check_unsubscribe(int, char*[]);
int mqtt5_first_byte_reserved_header_check_disconnect(int, char*[]);
int mqtt5_client_direct_connect_success(int, char*[]);
int mqtt5_client_direct_connect_sync_channel_failure(int, char*[]);
int mqtt5_client_direct_connect_async_channel_failure(int, char*[]);
int mqtt5_client_websocket_connect_sync_channel_failure(int, char*[]);
int mqtt5_client_websocket_connect_async_channel_failure(int, char*[]);
int mqtt5_client_websocket_connect_handshake_failure(int, char*[]);
int mqtt5_client_direct_connect_connack_refusal(int, char*[]);
int mqtt5_client_direct_connect_connack_timeout(int, char*[]);
int mqtt5_client_direct_connect_from_server_disconnect(int, char*[]);
int mqtt5_client_subscribe_success(int, char*[]);
int mqtt5_client_unsubscribe_success(int, char*[]);
int mqtt5_client_sub_pub_unsub_qos0(int, char*[]);
int mqtt5_client_sub_pub_unsub_qos1(int, char*[]);
int mqtt5_client_ping_sequence(int, char*[]);
int mqtt5_client_ping_timeout(int, char*[]);
int mqtt5_client_ping_timeout_with_keep_alive_conflict(int, char*[]);
int mqtt5_client_disabled_keep_alive(int, char*[]);
int mqtt5_client_reconnect_failure_backoff(int, char*[]);
int mqtt5_client_reconnect_backoff_insufficient_reset(int, char*[]);
int mqtt5_client_reconnect_backoff_sufficient_reset(int, char*[]);
int mqtt5_client_subscribe_fail_packet_too_big(int, char*[]);
int mqtt5_client_disconnect_fail_packet_too_big(int, char*[]);
int mqtt5_client_flow_control_receive_maximum(int, char*[]);
int mqtt5_client_publish_timeout(int, char*[]);
int mqtt5_client_dynamic_operation_timeout(int, char*[]);
int mqtt5_client_dynamic_operation_timeout_default(int, char*[]);
int mqtt5_client_flow_control_iot_core_throughput(int, char*[]);
int mqtt5_client_flow_control_iot_core_publish_tps(int, char*[]);
int mqtt5_client_session_resumption_clean_start(int, char*[]);
int mqtt5_client_session_resumption_post_success(int, char*[]);
int mqtt5_client_session_resumption_always(int, char*[]);
int mqtt5_client_receive_qos1_return_puback_test(int, char*[]);
int mqtt5_client_receive_nonexisting_session_state(int, char*[]);
int mqtt5_client_receive_assigned_client_id(int, char*[]);
int mqtt5_client_no_session_after_client_stop(int, char*[]);
int mqtt5_client_restore_session_on_ping_timeout_reconnect(int, char*[]);
int mqtt5_client_discard_session_on_server_clean_start(int, char*[]);
int mqtt5_client_statistics_subscribe(int, char*[]);
int mqtt5_client_statistics_unsubscribe(int, char*[]);
int mqtt5_client_statistics_publish_qos0(int, char*[]);
int mqtt5_client_statistics_publish_qos1(int, char*[]);
int mqtt5_client_statistics_publish_qos1_requeue(int, char*[]);
int mqtt5_client_puback_ordering(int, char*[]);
int mqtt5_client_listeners(int, char*[]);
int mqtt5_client_offline_operation_submission_fail_all(int, char*[]);
int mqtt5_client_offline_operation_submission_fail_qos0(int, char*[]);
int mqtt5_client_offline_operation_submission_fail_non_qos1(int, char*[]);
int mqtt5_client_offline_operation_submission_then_connect(int, char*[]);
int mqtt5_client_inbound_alias_success(int, char*[]);
int mqtt5_client_inbound_alias_failure_disabled(int, char*[]);
int mqtt5_client_inbound_alias_failure_zero_id(int, char*[]);
int mqtt5_client_inbound_alias_failure_too_large_id(int, char*[]);
int mqtt5_client_inbound_alias_failure_unbound_id(int, char*[]);
int mqtt5_client_outbound_alias_manual_failure_empty_topic(int, char*[]);
int mqtt5_client_outbound_alias_manual_success_a_b_ar_br(int, char*[]);
int mqtt5_client_outbound_alias_lru_success_a_b_c_br_cr_a(int, char*[]);
int rate_limiter_token_bucket_init_invalid(int, char*[]);
int rate_limiter_token_bucket_regeneration_integral(int, char*[]);
int rate_limiter_token_bucket_regeneration_fractional(int, char*[]);
int rate_limiter_token_bucket_fractional_iteration(int, char*[]);
int rate_limiter_token_bucket_large_fractional_iteration(int, char*[]);
int rate_limiter_token_bucket_real_iteration(int, char*[]);
int rate_limiter_token_bucket_reset(int, char*[]);
int mqtt5to3_adapter_create_destroy(int, char*[]);
int mqtt5to3_adapter_create_destroy_delayed(int, char*[]);
int mqtt5to3_adapter_set_will(int, char*[]);
int mqtt5to3_adapter_set_login(int, char*[]);
int mqtt5to3_adapter_set_reconnect_timeout(int, char*[]);
int mqtt5to3_adapter_connect_success(int, char*[]);
int mqtt5to3_adapter_connect_success_disconnect_success(int, char*[]);
int mqtt5to3_adapter_connect_success_disconnect_success_thrice(int, char*[]);
int mqtt5to3_adapter_connect_success_connect_failure(int, char*[]);
int mqtt5to3_adapter_connect_success_sloppy_shutdown(int, char*[]);
int mqtt5to3_adapter_connect_bad_connectivity(int, char*[]);
int mqtt5to3_adapter_connect_bad_connectivity_with_mqtt5_restart(int, char*[]);
int mqtt5to3_adapter_connect_failure_connect_success_via_mqtt5(int, char*[]);
int mqtt5to3_adapter_connect_failure_bad_config_success_good_config(int, char*[]);
int mqtt5to3_adapter_connect_reconnect_failures(int, char*[]);
int mqtt5to3_adapter_connect_success_disconnect_connect(int, char*[]);
int mqtt5to3_adapter_connect_success_stop_mqtt5_disconnect_success(int, char*[]);
int mqtt5to3_adapter_disconnect_success(int, char*[]);
int mqtt5to3_adapter_connect_success_disconnect_success_disconnect_success(int, char*[]);
int mqtt5to3_adapter_operation_allocation_simple(int, char*[]);
int mqtt5to3_adapter_operation_allocation_wraparound(int, char*[]);
int mqtt5to3_adapter_operation_allocation_exhaustion(int, char*[]);
int mqtt5to3_adapter_publish_failure_invalid(int, char*[]);
int mqtt5to3_adapter_publish_failure_offline_queue_policy(int, char*[]);
int mqtt5to3_adapter_publish_success_qos0(int, char*[]);
int mqtt5to3_adapter_publish_success_qos1(int, char*[]);
int mqtt5to3_adapter_publish_qos1_fail_ack(int, char*[]);
int mqtt5to3_adapter_publish_no_ack(int, char*[]);
int mqtt5to3_adapter_publish_interrupted(int, char*[]);
int mqtt5to3_adapter_subscribe_single_success(int, char*[]);
int mqtt5to3_adapter_subscribe_multi_success(int, char*[]);
int mqtt5to3_adapter_subscribe_single_failure(int, char*[]);
int mqtt5to3_adapter_subscribe_single_invalid(int, char*[]);
int mqtt5to3_adapter_subscribe_multi_failure(int, char*[]);
int mqtt5to3_adapter_subscribe_multi_invalid(int, char*[]);
int mqtt5to3_adapter_subscribe_single_publish(int, char*[]);
int mqtt5to3_adapter_subscribe_multi_overlapping_publish(int, char*[]);
int mqtt5to3_adapter_unsubscribe_success(int, char*[]);
int mqtt5to3_adapter_unsubscribe_failure(int, char*[]);
int mqtt5to3_adapter_unsubscribe_invalid(int, char*[]);
int mqtt5to3_adapter_unsubscribe_overlapped(int, char*[]);
int mqtt5to3_adapter_get_stats(int, char*[]);
int mqtt5to3_adapter_resubscribe_nothing(int, char*[]);
int mqtt5to3_adapter_resubscribe_something(int, char*[]);
int mqtt5to3_adapter_subscribe_single_null_suback(int, char*[]);
int mqtt5to3_adapter_subscribe_multi_null_suback(int, char*[]);
int mqtt5to3_adapter_operation_callbacks_after_shutdown(int, char*[]);
int mqtt_subscription_set_add_empty_not_subbed(int, char*[]);
int mqtt_subscription_set_add_single_path(int, char*[]);
int mqtt_subscription_set_add_overlapped_branching_paths(int, char*[]);
int mqtt_subscription_set_remove_overlapping_path(int, char*[]);
int mqtt_subscription_set_remove_branching_path(int, char*[]);
int mqtt_subscription_set_remove_invalid(int, char*[]);
int mqtt_subscription_set_remove_empty_segments(int, char*[]);
int mqtt_subscription_set_add_remove_repeated(int, char*[]);
int mqtt_subscription_set_publish_single_path(int, char*[]);
int mqtt_subscription_set_publish_multi_path(int, char*[]);
int mqtt_subscription_set_publish_single_level_wildcards(int, char*[]);
int mqtt_subscription_set_publish_multi_level_wildcards(int, char*[]);
int mqtt_subscription_set_get_subscriptions(int, char*[]);
int request_response_mqtt5_protocol_adapter_subscribe_success(int, char*[]);
int request_response_mqtt5_protocol_adapter_subscribe_failure_error_code(int, char*[]);
int request_response_mqtt5_protocol_adapter_subscribe_failure_reason_code(int, char*[]);
int request_response_mqtt5_protocol_adapter_subscribe_failure_timeout(int, char*[]);
int request_response_mqtt5_protocol_adapter_unsubscribe_success(int, char*[]);
int request_response_mqtt5_protocol_adapter_unsubscribe_failure_error_code(int, char*[]);
int request_response_mqtt5_protocol_adapter_unsubscribe_failure_reason_code_retryable(int, char*[]);
int request_response_mqtt5_protocol_adapter_unsubscribe_failure_reason_code_not_retryable(int, char*[]);
int request_response_mqtt5_protocol_adapter_unsubscribe_failure_timeout(int, char*[]);
int request_response_mqtt5_protocol_adapter_publish_success(int, char*[]);
int request_response_mqtt5_protocol_adapter_publish_failure_error_code(int, char*[]);
int request_response_mqtt5_protocol_adapter_publish_failure_reason_code(int, char*[]);
int request_response_mqtt5_protocol_adapter_publish_failure_timeout(int, char*[]);
int request_response_mqtt5_protocol_adapter_connection_event_connect_no_session(int, char*[]);
int request_response_mqtt5_protocol_adapter_connection_event_connect_session(int, char*[]);
int request_response_mqtt5_protocol_adapter_incoming_publish(int, char*[]);
int request_response_mqtt5_protocol_adapter_shutdown_while_pending(int, char*[]);
int request_response_mqtt311_protocol_adapter_subscribe_success(int, char*[]);
int request_response_mqtt311_protocol_adapter_subscribe_failure_timeout(int, char*[]);
int request_response_mqtt311_protocol_adapter_subscribe_failure_reason_code(int, char*[]);
int request_response_mqtt311_protocol_adapter_unsubscribe_success(int, char*[]);
int request_response_mqtt311_protocol_adapter_unsubscribe_failure_timeout(int, char*[]);
int request_response_mqtt311_protocol_adapter_publish_success(int, char*[]);
int request_response_mqtt311_protocol_adapter_publish_failure_timeout(int, char*[]);
int request_response_mqtt311_protocol_adapter_connection_events(int, char*[]);
int request_response_mqtt311_protocol_adapter_incoming_publish(int, char*[]);
int request_response_mqtt311_protocol_adapter_shutdown_while_pending(int, char*[]);
int mqtt311_listener_connection_events_no_session(int, char*[]);
int mqtt311_listener_connection_events_with_session(int, char*[]);
int mqtt311_listener_publish_event(int, char*[]);
int rrsm_acquire_subscribing(int, char*[]);
int rrsm_acquire_multi_subscribing(int, char*[]);
int rrsm_acquire_existing_subscribing(int, char*[]);
int rrsm_acquire_multi_existing_subscribing(int, char*[]);
int rrsm_acquire_multi_partially_subscribed(int, char*[]);
int rrsm_acquire_existing_subscribed(int, char*[]);
int rrsm_acquire_multi_existing_subscribed(int, char*[]);
int rrsm_acquire_blocked_rr(int, char*[]);
int rrsm_acquire_multi_blocked_rr(int, char*[]);
int rrsm_acquire_blocked_eventstream(int, char*[]);
int rrsm_acquire_multi_blocked_eventstream(int, char*[]);
int rrsm_acquire_no_capacity_max1(int, char*[]);
int rrsm_acquire_no_capacity_too_many_event_stream(int, char*[]);
int rrsm_acquire_multi_no_capacity_event_stream(int, char*[]);
int rrsm_acquire_failure_mixed_subscription_types(int, char*[]);
int rrsm_acquire_multi_failure_mixed_subscription_types(int, char*[]);
int rrsm_acquire_failure_poisoned(int, char*[]);
int rrsm_release_unsubscribes_request(int, char*[]);
int rrsm_release_unsubscribes_streaming(int, char*[]);
int rrsm_release_multi_unsubscribes_request(int, char*[]);
int rrsm_release_unsubscribe_success_clears_space(int, char*[]);
int rrsm_release_unsubscribe_failure_blocked(int, char*[]);
int rrsm_acquire_failure_subscribe_sync_failure_request(int, char*[]);
int rrsm_acquire_failure_subscribe_sync_failure_streaming(int, char*[]);
int rrsm_acquire_request_subscribe_failure_event(int, char*[]);
int rrsm_acquire_streaming_subscribe_failure_retryable_resubscribe(int, char*[]);
int rrsm_offline_acquire_request_online_success(int, char*[]);
int rrsm_offline_acquire_request_online_failure(int, char*[]);
int rrsm_offline_acquire_streaming_online_success(int, char*[]);
int rrsm_offline_acquire_streaming_online_failure(int, char*[]);
int rrsm_offline_acquire_release_request_online(int, char*[]);
int rrsm_offline_acquire_release_streaming_online(int, char*[]);
int rrsm_acquire_request_success_offline_release_acquire2_no_unsubscribe(int, char*[]);
int rrsm_acquire_streaming_success_offline_release_acquire2_no_unsubscribe(int, char*[]);
int rrsm_acquire_request_success_clean_up_unsubscribe_override(int, char*[]);
int rrsm_acquire_streaming_success_clean_up_unsubscribe_override(int, char*[]);
int rrsm_acquire_request_pending_clean_up_unsubscribe_override(int, char*[]);
int rrsm_acquire_streaming_pending_clean_up_unsubscribe_override(int, char*[]);
int rrsm_offline_acquire_request_pending_clean_up_unsubscribe_override(int, char*[]);
int rrsm_offline_acquire_streaming_pending_clean_up_unsubscribe_override(int, char*[]);
int rrsm_acquire_request_success_offline_online_no_session_subscription_ended_can_reacquire(int, char*[]);
int rrsm_request_subscription_ended_while_unsubscribing(int, char*[]);
int rrsm_streaming_subscription_lost_resubscribe_on_no_session(int, char*[]);
int rrsm_request_subscription_purge_events(int, char*[]);
int rrsm_streaming_subscription_purge_events(int, char*[]);
int rrc_mqtt5_create_destroy(int, char*[]);
int rrc_mqtt311_create_destroy(int, char*[]);
int rrc_submit_request_operation_failure_no_response_paths(int, char*[]);
int rrc_submit_request_operation_failure_invalid_response_topic(int, char*[]);
int rrc_submit_request_operation_failure_invalid_publish_topic(int, char*[]);
int rrc_submit_request_operation_failure_invalid_subscription_topic_filter(int, char*[]);
int rrc_submit_request_operation_failure_no_subscription_topic_filters(int, char*[]);
int rrc_submit_request_operation_failure_empty_request(int, char*[]);
int rrc_submit_streaming_operation_failure_invalid_subscription_topic_filter(int, char*[]);
int rrc_submit_request_operation_failure_by_shutdown(int, char*[]);
int rrc_create_streaming_operation_and_shutdown(int, char*[]);
int rrc_activate_streaming_operation_and_shutdown(int, char*[]);
int rrc_submit_request_operation_failure_by_timeout(int, char*[]);
int rrc_streaming_operation_success_single(int, char*[]);
int rrc_streaming_operation_success_overlapping(int, char*[]);
int rrc_streaming_operation_success_starting_offline(int, char*[]);
int rrc_streaming_operation_clean_session_reestablish_subscription(int, char*[]);
int rrc_streaming_operation_resume_session(int, char*[]);
int rrc_streaming_operation_first_subscribe_times_out_resub_succeeds(int, char*[]);
int rrc_streaming_operation_first_subscribe_retryable_failure_resub_succeeds(int, char*[]);
int rrc_streaming_operation_subscribe_unretryable_failure(int, char*[]);
int rrc_streaming_operation_failure_exceeds_subscription_budget(int, char*[]);
int rrc_streaming_operation_success_delayed_by_request_operations(int, char*[]);
int rrc_streaming_operation_success_sandwiched_by_request_operations(int, char*[]);
int rrc_request_response_success_response_path_accepted(int, char*[]);
int rrc_request_response_multi_sub_success_response_path_accepted(int, char*[]);
int rrc_request_response_success_response_path_rejected(int, char*[]);
int rrc_request_response_multi_sub_success_response_path_rejected(int, char*[]);
int rrc_request_response_success_empty_correlation_token(int, char*[]);
int rrc_request_response_success_empty_correlation_token_sequence(int, char*[]);
int rrc_request_response_subscribe_failure(int, char*[]);
int rrc_request_response_multi_subscribe_failure(int, char*[]);
int rrc_request_response_failure_puback_reason_code(int, char*[]);
int rrc_request_response_failure_invalid_payload(int, char*[]);
int rrc_request_response_failure_missing_correlation_token(int, char*[]);
int rrc_request_response_failure_invalid_correlation_token_type(int, char*[]);
int rrc_request_response_failure_non_matching_correlation_token(int, char*[]);
int rrc_request_response_multi_operation_sequence(int, char*[]);


#ifdef __cplusplus
#  define CM_CAST(TYPE, EXPR) static_cast<TYPE>(EXPR)
#  if __cplusplus >= 201103L
#    define CM_NULL nullptr
#  else
#    define CM_NULL NULL
#  endif
#  define CM_NAMESPACE_BEGIN namespace {
#  define CM_NAMESPACE_END }
#  define CM_LOCAL
#else
#  define CM_CAST(TYPE, EXPR) (TYPE)(EXPR)
#  define CM_NULL NULL
#  define CM_NAMESPACE_BEGIN
#  define CM_NAMESPACE_END
#  define CM_LOCAL static
#endif

CM_NAMESPACE_BEGIN

/* Create map.  */

typedef int (*MainFuncPointer)(int, char* []); /* NOLINT */
typedef struct /* NOLINT */
{
  const char* name;
  MainFuncPointer func;
} functionMapEntry;

CM_LOCAL const functionMapEntry cmakeGeneratedFunctionMapEntries[] = {
    {
    "mqtt_packet_puback",
    mqtt_packet_puback
  },
  {
    "mqtt_packet_pubrec",
    mqtt_packet_pubrec
  },
  {
    "mqtt_packet_pubrel",
    mqtt_packet_pubrel
  },
  {
    "mqtt_packet_pubcomp",
    mqtt_packet_pubcomp
  },
  {
    "mqtt_packet_suback",
    mqtt_packet_suback
  },
  {
    "mqtt_packet_unsuback",
    mqtt_packet_unsuback
  },
  {
    "mqtt_packet_connect",
    mqtt_packet_connect
  },
  {
    "mqtt_packet_connect_will",
    mqtt_packet_connect_will
  },
  {
    "mqtt_packet_connect_empty_payload_will",
    mqtt_packet_connect_empty_payload_will
  },
  {
    "mqtt_packet_connect_password",
    mqtt_packet_connect_password
  },
  {
    "mqtt_packet_connect_all",
    mqtt_packet_connect_all
  },
  {
    "mqtt_packet_connack",
    mqtt_packet_connack
  },
  {
    "mqtt_packet_publish_qos0_dup",
    mqtt_packet_publish_qos0_dup
  },
  {
    "mqtt_packet_publish_qos2_retain",
    mqtt_packet_publish_qos2_retain
  },
  {
    "mqtt_packet_publish_empty_payload",
    mqtt_packet_publish_empty_payload
  },
  {
    "mqtt_packet_subscribe",
    mqtt_packet_subscribe
  },
  {
    "mqtt_packet_unsubscribe",
    mqtt_packet_unsubscribe
  },
  {
    "mqtt_packet_pingreq",
    mqtt_packet_pingreq
  },
  {
    "mqtt_packet_pingresp",
    mqtt_packet_pingresp
  },
  {
    "mqtt_packet_disconnect",
    mqtt_packet_disconnect
  },
  {
    "mqtt_packet_connack_decode_failure_reserved",
    mqtt_packet_connack_decode_failure_reserved
  },
  {
    "mqtt_packet_ack_decode_failure_reserved",
    mqtt_packet_ack_decode_failure_reserved
  },
  {
    "mqtt_packet_pingresp_decode_failure_reserved",
    mqtt_packet_pingresp_decode_failure_reserved
  },
  {
    "mqtt_frame_and_decode_publish",
    mqtt_frame_and_decode_publish
  },
  {
    "mqtt_frame_and_decode_suback",
    mqtt_frame_and_decode_suback
  },
  {
    "mqtt_frame_and_decode_unsuback",
    mqtt_frame_and_decode_unsuback
  },
  {
    "mqtt_frame_and_decode_puback",
    mqtt_frame_and_decode_puback
  },
  {
    "mqtt_frame_and_decode_pingresp",
    mqtt_frame_and_decode_pingresp
  },
  {
    "mqtt_frame_and_decode_connack",
    mqtt_frame_and_decode_connack
  },
  {
    "mqtt_frame_and_decode_bad_remaining_length",
    mqtt_frame_and_decode_bad_remaining_length
  },
  {
    "mqtt_frame_and_decode_unsupported_packet_type",
    mqtt_frame_and_decode_unsupported_packet_type
  },
  {
    "mqtt_frame_and_decode_bad_flags_for_packet_type",
    mqtt_frame_and_decode_bad_flags_for_packet_type
  },
  {
    "mqtt_topic_tree_match",
    mqtt_topic_tree_match
  },
  {
    "mqtt_topic_tree_unsubscribe",
    mqtt_topic_tree_unsubscribe
  },
  {
    "mqtt_topic_tree_duplicate_transactions",
    mqtt_topic_tree_duplicate_transactions
  },
  {
    "mqtt_topic_tree_transactions",
    mqtt_topic_tree_transactions
  },
  {
    "mqtt_topic_validation",
    mqtt_topic_validation
  },
  {
    "mqtt_topic_filter_validation",
    mqtt_topic_filter_validation
  },
  {
    "mqtt_connect_disconnect",
    mqtt_connect_disconnect
  },
  {
    "mqtt_connect_set_will_login",
    mqtt_connect_set_will_login
  },
  {
    "mqtt_connection_interrupted",
    mqtt_connection_interrupted
  },
  {
    "mqtt_connection_any_publish",
    mqtt_connection_any_publish
  },
  {
    "mqtt_connection_timeout",
    mqtt_connection_timeout
  },
  {
    "mqtt_connection_connack_timeout",
    mqtt_connection_connack_timeout
  },
  {
    "mqtt_connection_failure_callback",
    mqtt_connection_failure_callback
  },
  {
    "mqtt_connection_success_callback",
    mqtt_connection_success_callback
  },
  {
    "mqtt_connect_subscribe",
    mqtt_connect_subscribe
  },
  {
    "mqtt_connect_subscribe_fail_from_broker",
    mqtt_connect_subscribe_fail_from_broker
  },
  {
    "mqtt_connect_subscribe_multi",
    mqtt_connect_subscribe_multi
  },
  {
    "mqtt_connect_subscribe_incoming_dup",
    mqtt_connect_subscribe_incoming_dup
  },
  {
    "mqtt_connect_unsubscribe",
    mqtt_connect_unsubscribe
  },
  {
    "mqtt_connect_resubscribe",
    mqtt_connect_resubscribe
  },
  {
    "mqtt_connect_publish",
    mqtt_connect_publish
  },
  {
    "mqtt_connect_publish_payload",
    mqtt_connect_publish_payload
  },
  {
    "mqtt_connection_offline_publish",
    mqtt_connection_offline_publish
  },
  {
    "mqtt_connection_disconnect_while_reconnecting",
    mqtt_connection_disconnect_while_reconnecting
  },
  {
    "mqtt_connection_closes_while_making_requests",
    mqtt_connection_closes_while_making_requests
  },
  {
    "mqtt_connection_resend_packets",
    mqtt_connection_resend_packets
  },
  {
    "mqtt_connection_consistent_retry_policy",
    mqtt_connection_consistent_retry_policy
  },
  {
    "mqtt_connection_not_resend_packets_on_healthy_connection",
    mqtt_connection_not_resend_packets_on_healthy_connection
  },
  {
    "mqtt_connection_destory_pending_requests",
    mqtt_connection_destory_pending_requests
  },
  {
    "mqtt_clean_session_not_retry",
    mqtt_clean_session_not_retry
  },
  {
    "mqtt_clean_session_discard_previous",
    mqtt_clean_session_discard_previous
  },
  {
    "mqtt_clean_session_keep_next_session",
    mqtt_clean_session_keep_next_session
  },
  {
    "mqtt_connection_publish_QoS1_timeout",
    mqtt_connection_publish_QoS1_timeout
  },
  {
    "mqtt_connection_publish_QoS1_timeout_override",
    mqtt_connection_publish_QoS1_timeout_override
  },
  {
    "mqtt_connection_unsubscribe_timeout",
    mqtt_connection_unsubscribe_timeout
  },
  {
    "mqtt_connection_unsubscribe_timeout_override",
    mqtt_connection_unsubscribe_timeout_override
  },
  {
    "mqtt_connection_subscribe_single_timeout",
    mqtt_connection_subscribe_single_timeout
  },
  {
    "mqtt_connection_subscribe_single_timeout_override",
    mqtt_connection_subscribe_single_timeout_override
  },
  {
    "mqtt_connection_subscribe_multi_timeout",
    mqtt_connection_subscribe_multi_timeout
  },
  {
    "mqtt_connection_resubscribe_timeout",
    mqtt_connection_resubscribe_timeout
  },
  {
    "mqtt_connection_publish_QoS1_timeout_with_ping",
    mqtt_connection_publish_QoS1_timeout_with_ping
  },
  {
    "mqtt_connection_publish_QoS1_timeout_connection_lost_reset_time",
    mqtt_connection_publish_QoS1_timeout_connection_lost_reset_time
  },
  {
    "mqtt_connection_ping_norm",
    mqtt_connection_ping_norm
  },
  {
    "mqtt_connection_ping_no",
    mqtt_connection_ping_no
  },
  {
    "mqtt_connection_ping_noack",
    mqtt_connection_ping_noack
  },
  {
    "mqtt_connection_ping_basic_scenario",
    mqtt_connection_ping_basic_scenario
  },
  {
    "mqtt_connection_ping_double_scenario",
    mqtt_connection_ping_double_scenario
  },
  {
    "mqtt_connection_close_callback_simple",
    mqtt_connection_close_callback_simple
  },
  {
    "mqtt_connection_close_callback_interrupted",
    mqtt_connection_close_callback_interrupted
  },
  {
    "mqtt_connection_close_callback_multi",
    mqtt_connection_close_callback_multi
  },
  {
    "mqtt_connection_reconnection_backoff_stable",
    mqtt_connection_reconnection_backoff_stable
  },
  {
    "mqtt_connection_reconnection_backoff_unstable",
    mqtt_connection_reconnection_backoff_unstable
  },
  {
    "mqtt_connection_reconnection_backoff_reset",
    mqtt_connection_reconnection_backoff_reset
  },
  {
    "mqtt_connection_reconnection_backoff_reset_after_disconnection",
    mqtt_connection_reconnection_backoff_reset_after_disconnection
  },
  {
    "mqtt_validation_failure_publish_qos",
    mqtt_validation_failure_publish_qos
  },
  {
    "mqtt_validation_failure_invalid_will_qos",
    mqtt_validation_failure_invalid_will_qos
  },
  {
    "mqtt_validation_failure_subscribe_empty",
    mqtt_validation_failure_subscribe_empty
  },
  {
    "mqtt_validation_failure_unsubscribe_null",
    mqtt_validation_failure_unsubscribe_null
  },
  {
    "mqtt_validation_failure_connect_invalid_client_id_utf8",
    mqtt_validation_failure_connect_invalid_client_id_utf8
  },
  {
    "mqtt_validation_failure_invalid_will_topic_utf8",
    mqtt_validation_failure_invalid_will_topic_utf8
  },
  {
    "mqtt_validation_failure_invalid_username_utf8",
    mqtt_validation_failure_invalid_username_utf8
  },
  {
    "mqtt_operation_statistics_simple_publish",
    mqtt_operation_statistics_simple_publish
  },
  {
    "mqtt_operation_statistics_offline_publish",
    mqtt_operation_statistics_offline_publish
  },
  {
    "mqtt_operation_statistics_disconnect_publish",
    mqtt_operation_statistics_disconnect_publish
  },
  {
    "mqtt_operation_statistics_reconnect_publish",
    mqtt_operation_statistics_reconnect_publish
  },
  {
    "mqtt_operation_statistics_simple_subscribe",
    mqtt_operation_statistics_simple_subscribe
  },
  {
    "mqtt_operation_statistics_simple_unsubscribe",
    mqtt_operation_statistics_simple_unsubscribe
  },
  {
    "mqtt_operation_statistics_simple_resubscribe",
    mqtt_operation_statistics_simple_resubscribe
  },
  {
    "mqtt_operation_statistics_simple_callback",
    mqtt_operation_statistics_simple_callback
  },
  {
    "mqtt_connection_termination_callback_simple",
    mqtt_connection_termination_callback_simple
  },
  {
    "mqtt5_topic_skip_rules_prefix",
    mqtt5_topic_skip_rules_prefix
  },
  {
    "mqtt5_topic_get_segment_count",
    mqtt5_topic_get_segment_count
  },
  {
    "mqtt5_shared_subscription_validation",
    mqtt5_shared_subscription_validation
  },
  {
    "mqtt_utf8_encoded_string_test",
    mqtt_utf8_encoded_string_test
  },
  {
    "mqtt5_inbound_topic_alias_register_failure",
    mqtt5_inbound_topic_alias_register_failure
  },
  {
    "mqtt5_inbound_topic_alias_resolve_success",
    mqtt5_inbound_topic_alias_resolve_success
  },
  {
    "mqtt5_inbound_topic_alias_resolve_failure",
    mqtt5_inbound_topic_alias_resolve_failure
  },
  {
    "mqtt5_inbound_topic_alias_reset",
    mqtt5_inbound_topic_alias_reset
  },
  {
    "mqtt5_outbound_topic_alias_disabled_resolve_success",
    mqtt5_outbound_topic_alias_disabled_resolve_success
  },
  {
    "mqtt5_outbound_topic_alias_disabled_resolve_failure",
    mqtt5_outbound_topic_alias_disabled_resolve_failure
  },
  {
    "mqtt5_outbound_topic_alias_manual_resolve_failure_zero_alias",
    mqtt5_outbound_topic_alias_manual_resolve_failure_zero_alias
  },
  {
    "mqtt5_outbound_topic_alias_manual_resolve_failure_too_big_alias",
    mqtt5_outbound_topic_alias_manual_resolve_failure_too_big_alias
  },
  {
    "mqtt5_outbound_topic_alias_manual_resolve_success",
    mqtt5_outbound_topic_alias_manual_resolve_success
  },
  {
    "mqtt5_outbound_topic_alias_manual_reset",
    mqtt5_outbound_topic_alias_manual_reset
  },
  {
    "mqtt5_outbound_topic_alias_lru_zero_size",
    mqtt5_outbound_topic_alias_lru_zero_size
  },
  {
    "mqtt5_outbound_topic_alias_lru_a_ar",
    mqtt5_outbound_topic_alias_lru_a_ar
  },
  {
    "mqtt5_outbound_topic_alias_lru_b_a_br",
    mqtt5_outbound_topic_alias_lru_b_a_br
  },
  {
    "mqtt5_outbound_topic_alias_lru_a_b_ar_br",
    mqtt5_outbound_topic_alias_lru_a_b_ar_br
  },
  {
    "mqtt5_outbound_topic_alias_lru_a_b_c_br_cr_br_cr_a",
    mqtt5_outbound_topic_alias_lru_a_b_c_br_cr_br_cr_a
  },
  {
    "mqtt5_outbound_topic_alias_lru_a_b_c_a_cr_b",
    mqtt5_outbound_topic_alias_lru_a_b_c_a_cr_b
  },
  {
    "mqtt5_outbound_topic_alias_lru_a_b_reset_a_b",
    mqtt5_outbound_topic_alias_lru_a_b_reset_a_b
  },
  {
    "mqtt5_publish_operation_new_set_no_optional",
    mqtt5_publish_operation_new_set_no_optional
  },
  {
    "mqtt5_publish_operation_new_set_all",
    mqtt5_publish_operation_new_set_all
  },
  {
    "mqtt5_publish_operation_new_failure_packet_id",
    mqtt5_publish_operation_new_failure_packet_id
  },
  {
    "mqtt5_subscribe_operation_new_set_no_optional",
    mqtt5_subscribe_operation_new_set_no_optional
  },
  {
    "mqtt5_subscribe_operation_new_set_all",
    mqtt5_subscribe_operation_new_set_all
  },
  {
    "mqtt5_unsubscribe_operation_new_set_all",
    mqtt5_unsubscribe_operation_new_set_all
  },
  {
    "mqtt5_connect_storage_new_set_no_optional",
    mqtt5_connect_storage_new_set_no_optional
  },
  {
    "mqtt5_connect_storage_new_set_all",
    mqtt5_connect_storage_new_set_all
  },
  {
    "mqtt5_connack_storage_new_set_no_optional",
    mqtt5_connack_storage_new_set_no_optional
  },
  {
    "mqtt5_connack_storage_new_set_all",
    mqtt5_connack_storage_new_set_all
  },
  {
    "mqtt5_disconnect_storage_new_set_no_optional",
    mqtt5_disconnect_storage_new_set_no_optional
  },
  {
    "mqtt5_disconnect_storage_new_set_all",
    mqtt5_disconnect_storage_new_set_all
  },
  {
    "mqtt5_suback_storage_new_set_no_optional",
    mqtt5_suback_storage_new_set_no_optional
  },
  {
    "mqtt5_suback_storage_new_set_all",
    mqtt5_suback_storage_new_set_all
  },
  {
    "mqtt5_unsuback_storage_new_set_no_optional",
    mqtt5_unsuback_storage_new_set_no_optional
  },
  {
    "mqtt5_unsuback_storage_new_set_all",
    mqtt5_unsuback_storage_new_set_all
  },
  {
    "mqtt5_puback_storage_new_set_all",
    mqtt5_puback_storage_new_set_all
  },
  {
    "mqtt5_publish_storage_new_set_all",
    mqtt5_publish_storage_new_set_all
  },
  {
    "mqtt5_operation_disconnect_validation_failure_server_reference",
    mqtt5_operation_disconnect_validation_failure_server_reference
  },
  {
    "mqtt5_operation_disconnect_validation_failure_bad_reason_code",
    mqtt5_operation_disconnect_validation_failure_bad_reason_code
  },
  {
    "mqtt5_operation_disconnect_validation_failure_reason_string_too_long",
    mqtt5_operation_disconnect_validation_failure_reason_string_too_long
  },
  {
    "mqtt5_operation_disconnect_validation_failure_reason_string_invalid_utf8",
    mqtt5_operation_disconnect_validation_failure_reason_string_invalid_utf8
  },
  {
    "mqtt5_operation_disconnect_validation_failure_user_properties_name_too_long",
    mqtt5_operation_disconnect_validation_failure_user_properties_name_too_long
  },
  {
    "mqtt5_operation_disconnect_validation_failure_user_properties_name_invalid_utf8",
    mqtt5_operation_disconnect_validation_failure_user_properties_name_invalid_utf8
  },
  {
    "mqtt5_operation_disconnect_validation_failure_user_properties_value_too_long",
    mqtt5_operation_disconnect_validation_failure_user_properties_value_too_long
  },
  {
    "mqtt5_operation_disconnect_validation_failure_user_properties_value_invalid_utf8",
    mqtt5_operation_disconnect_validation_failure_user_properties_value_invalid_utf8
  },
  {
    "mqtt5_operation_disconnect_validation_failure_user_properties_too_many",
    mqtt5_operation_disconnect_validation_failure_user_properties_too_many
  },
  {
    "mqtt5_operation_connect_validation_failure_client_id_too_long",
    mqtt5_operation_connect_validation_failure_client_id_too_long
  },
  {
    "mqtt5_operation_connect_validation_failure_client_id_invalid_utf8",
    mqtt5_operation_connect_validation_failure_client_id_invalid_utf8
  },
  {
    "mqtt5_operation_connect_validation_failure_username_too_long",
    mqtt5_operation_connect_validation_failure_username_too_long
  },
  {
    "mqtt5_operation_connect_validation_failure_username_invalid_utf8",
    mqtt5_operation_connect_validation_failure_username_invalid_utf8
  },
  {
    "mqtt5_operation_connect_validation_failure_password_too_long",
    mqtt5_operation_connect_validation_failure_password_too_long
  },
  {
    "mqtt5_operation_connect_validation_failure_receive_maximum_zero",
    mqtt5_operation_connect_validation_failure_receive_maximum_zero
  },
  {
    "mqtt5_operation_connect_validation_failure_maximum_packet_size_zero",
    mqtt5_operation_connect_validation_failure_maximum_packet_size_zero
  },
  {
    "mqtt5_operation_connect_validation_failure_will_invalid",
    mqtt5_operation_connect_validation_failure_will_invalid
  },
  {
    "mqtt5_operation_connect_validation_failure_will_payload_too_long",
    mqtt5_operation_connect_validation_failure_will_payload_too_long
  },
  {
    "mqtt5_operation_connect_validation_failure_auth_method_unsupported",
    mqtt5_operation_connect_validation_failure_auth_method_unsupported
  },
  {
    "mqtt5_operation_connect_validation_failure_auth_data_unsupported",
    mqtt5_operation_connect_validation_failure_auth_data_unsupported
  },
  {
    "mqtt5_operation_connect_validation_failure_request_problem_information_invalid",
    mqtt5_operation_connect_validation_failure_request_problem_information_invalid
  },
  {
    "mqtt5_operation_connect_validation_failure_request_response_information_invalid",
    mqtt5_operation_connect_validation_failure_request_response_information_invalid
  },
  {
    "mqtt5_operation_connect_validation_failure_user_properties_name_too_long",
    mqtt5_operation_connect_validation_failure_user_properties_name_too_long
  },
  {
    "mqtt5_operation_connect_validation_failure_user_properties_name_invalid_utf8",
    mqtt5_operation_connect_validation_failure_user_properties_name_invalid_utf8
  },
  {
    "mqtt5_operation_connect_validation_failure_user_properties_value_too_long",
    mqtt5_operation_connect_validation_failure_user_properties_value_too_long
  },
  {
    "mqtt5_operation_connect_validation_failure_user_properties_value_invalid_utf8",
    mqtt5_operation_connect_validation_failure_user_properties_value_invalid_utf8
  },
  {
    "mqtt5_operation_connect_validation_failure_user_properties_too_many",
    mqtt5_operation_connect_validation_failure_user_properties_too_many
  },
  {
    "mqtt5_operation_subscribe_validation_failure_no_subscriptions",
    mqtt5_operation_subscribe_validation_failure_no_subscriptions
  },
  {
    "mqtt5_operation_subscribe_validation_failure_too_many_subscriptions",
    mqtt5_operation_subscribe_validation_failure_too_many_subscriptions
  },
  {
    "mqtt5_operation_subscribe_validation_failure_invalid_subscription_identifier",
    mqtt5_operation_subscribe_validation_failure_invalid_subscription_identifier
  },
  {
    "mqtt5_operation_subscribe_validation_failure_invalid_topic_filter",
    mqtt5_operation_subscribe_validation_failure_invalid_topic_filter
  },
  {
    "mqtt5_operation_subscribe_validation_failure_invalid_utf8_topic_filter",
    mqtt5_operation_subscribe_validation_failure_invalid_utf8_topic_filter
  },
  {
    "mqtt5_operation_subscribe_validation_failure_invalid_qos",
    mqtt5_operation_subscribe_validation_failure_invalid_qos
  },
  {
    "mqtt5_operation_subscribe_validation_failure_invalid_retain_type",
    mqtt5_operation_subscribe_validation_failure_invalid_retain_type
  },
  {
    "mqtt5_operation_subscribe_validation_failure_invalid_no_local",
    mqtt5_operation_subscribe_validation_failure_invalid_no_local
  },
  {
    "mqtt5_operation_subscribe_validation_failure_user_properties_name_too_long",
    mqtt5_operation_subscribe_validation_failure_user_properties_name_too_long
  },
  {
    "mqtt5_operation_subscribe_validation_failure_user_properties_name_invalid_utf8",
    mqtt5_operation_subscribe_validation_failure_user_properties_name_invalid_utf8
  },
  {
    "mqtt5_operation_subscribe_validation_failure_user_properties_value_too_long",
    mqtt5_operation_subscribe_validation_failure_user_properties_value_too_long
  },
  {
    "mqtt5_operation_subscribe_validation_failure_user_properties_value_invalid_utf8",
    mqtt5_operation_subscribe_validation_failure_user_properties_value_invalid_utf8
  },
  {
    "mqtt5_operation_subscribe_validation_failure_user_properties_too_many",
    mqtt5_operation_subscribe_validation_failure_user_properties_too_many
  },
  {
    "mqtt5_operation_unsubscribe_validation_failure_no_topic_filters",
    mqtt5_operation_unsubscribe_validation_failure_no_topic_filters
  },
  {
    "mqtt5_operation_unsubscribe_validation_failure_too_many_topic_filters",
    mqtt5_operation_unsubscribe_validation_failure_too_many_topic_filters
  },
  {
    "mqtt5_operation_unsubscribe_validation_failure_invalid_topic_filter",
    mqtt5_operation_unsubscribe_validation_failure_invalid_topic_filter
  },
  {
    "mqtt5_operation_unsubscribe_validation_failure_invalid_utf8_topic_filter",
    mqtt5_operation_unsubscribe_validation_failure_invalid_utf8_topic_filter
  },
  {
    "mqtt5_operation_unsubscribe_validation_failure_user_properties_name_too_long",
    mqtt5_operation_unsubscribe_validation_failure_user_properties_name_too_long
  },
  {
    "mqtt5_operation_unsubscribe_validation_failure_user_properties_name_invalid_utf8",
    mqtt5_operation_unsubscribe_validation_failure_user_properties_name_invalid_utf8
  },
  {
    "mqtt5_operation_unsubscribe_validation_failure_user_properties_value_too_long",
    mqtt5_operation_unsubscribe_validation_failure_user_properties_value_too_long
  },
  {
    "mqtt5_operation_unsubscribe_validation_failure_user_properties_value_invalid_utf8",
    mqtt5_operation_unsubscribe_validation_failure_user_properties_value_invalid_utf8
  },
  {
    "mqtt5_operation_unsubscribe_validation_failure_user_properties_too_many",
    mqtt5_operation_unsubscribe_validation_failure_user_properties_too_many
  },
  {
    "mqtt5_operation_publish_validation_failure_invalid_topic",
    mqtt5_operation_publish_validation_failure_invalid_topic
  },
  {
    "mqtt5_operation_publish_validation_failure_invalid_utf8_topic",
    mqtt5_operation_publish_validation_failure_invalid_utf8_topic
  },
  {
    "mqtt5_operation_publish_validation_failure_no_topic",
    mqtt5_operation_publish_validation_failure_no_topic
  },
  {
    "mqtt5_operation_publish_validation_failure_invalid_payload_format",
    mqtt5_operation_publish_validation_failure_invalid_payload_format
  },
  {
    "mqtt5_operation_publish_validation_failure_invalid_utf8_payload",
    mqtt5_operation_publish_validation_failure_invalid_utf8_payload
  },
  {
    "mqtt5_operation_publish_validation_failure_response_topic_too_long",
    mqtt5_operation_publish_validation_failure_response_topic_too_long
  },
  {
    "mqtt5_operation_publish_validation_failure_invalid_response_topic",
    mqtt5_operation_publish_validation_failure_invalid_response_topic
  },
  {
    "mqtt5_operation_publish_validation_failure_invalid_utf8_response_topic",
    mqtt5_operation_publish_validation_failure_invalid_utf8_response_topic
  },
  {
    "mqtt5_operation_publish_validation_failure_correlation_data_too_long",
    mqtt5_operation_publish_validation_failure_correlation_data_too_long
  },
  {
    "mqtt5_operation_publish_validation_failure_content_type_too_long",
    mqtt5_operation_publish_validation_failure_content_type_too_long
  },
  {
    "mqtt5_operation_publish_validation_failure_invalid_utf8_content_type",
    mqtt5_operation_publish_validation_failure_invalid_utf8_content_type
  },
  {
    "mqtt5_operation_publish_validation_failure_subscription_identifier_exists",
    mqtt5_operation_publish_validation_failure_subscription_identifier_exists
  },
  {
    "mqtt5_operation_publish_validation_failure_topic_alias_zero",
    mqtt5_operation_publish_validation_failure_topic_alias_zero
  },
  {
    "mqtt5_operation_publish_validation_failure_user_properties_name_too_long",
    mqtt5_operation_publish_validation_failure_user_properties_name_too_long
  },
  {
    "mqtt5_operation_publish_validation_failure_user_properties_name_invalid_utf8",
    mqtt5_operation_publish_validation_failure_user_properties_name_invalid_utf8
  },
  {
    "mqtt5_operation_publish_validation_failure_user_properties_value_too_long",
    mqtt5_operation_publish_validation_failure_user_properties_value_too_long
  },
  {
    "mqtt5_operation_publish_validation_failure_user_properties_value_invalid_utf8",
    mqtt5_operation_publish_validation_failure_user_properties_value_invalid_utf8
  },
  {
    "mqtt5_operation_publish_validation_failure_user_properties_too_many",
    mqtt5_operation_publish_validation_failure_user_properties_too_many
  },
  {
    "mqtt5_operation_publish_validation_failure_qos0_duplicate_true",
    mqtt5_operation_publish_validation_failure_qos0_duplicate_true
  },
  {
    "mqtt5_operation_publish_validation_failure_qos0_with_packet_id",
    mqtt5_operation_publish_validation_failure_qos0_with_packet_id
  },
  {
    "mqtt5_client_options_validation_failure_no_host",
    mqtt5_client_options_validation_failure_no_host
  },
  {
    "mqtt5_client_options_validation_failure_no_bootstrap",
    mqtt5_client_options_validation_failure_no_bootstrap
  },
  {
    "mqtt5_client_options_validation_failure_no_publish_received",
    mqtt5_client_options_validation_failure_no_publish_received
  },
  {
    "mqtt5_client_options_validation_failure_invalid_socket_options",
    mqtt5_client_options_validation_failure_invalid_socket_options
  },
  {
    "mqtt5_client_options_validation_failure_invalid_connect",
    mqtt5_client_options_validation_failure_invalid_connect
  },
  {
    "mqtt5_client_options_validation_failure_invalid_port",
    mqtt5_client_options_validation_failure_invalid_port
  },
  {
    "mqtt5_operation_subscribe_connection_settings_validation_failure_exceeds_maximum_packet_size",
    mqtt5_operation_subscribe_connection_settings_validation_failure_exceeds_maximum_packet_size
  },
  {
    "mqtt5_operation_unsubscribe_connection_settings_validation_failure_exceeds_maximum_packet_size",
    mqtt5_operation_unsubscribe_connection_settings_validation_failure_exceeds_maximum_packet_size
  },
  {
    "mqtt5_operation_publish_connection_settings_validation_failure_exceeds_maximum_packet_size",
    mqtt5_operation_publish_connection_settings_validation_failure_exceeds_maximum_packet_size
  },
  {
    "mqtt5_operation_publish_connection_settings_validation_failure_exceeds_maximum_qos",
    mqtt5_operation_publish_connection_settings_validation_failure_exceeds_maximum_qos
  },
  {
    "mqtt5_operation_publish_connection_settings_validation_failure_invalid_retain",
    mqtt5_operation_publish_connection_settings_validation_failure_invalid_retain
  },
  {
    "mqtt5_operation_disconnect_connection_settings_validation_failure_exceeds_maximum_packet_size",
    mqtt5_operation_disconnect_connection_settings_validation_failure_exceeds_maximum_packet_size
  },
  {
    "mqtt5_operation_disconnect_connection_settings_validation_failure_promote_zero_session_expiry",
    mqtt5_operation_disconnect_connection_settings_validation_failure_promote_zero_session_expiry
  },
  {
    "mqtt5_client_options_defaults_set",
    mqtt5_client_options_defaults_set
  },
  {
    "mqtt5_operation_bind_packet_id_empty_table",
    mqtt5_operation_bind_packet_id_empty_table
  },
  {
    "mqtt5_operation_bind_packet_id_multiple_with_existing",
    mqtt5_operation_bind_packet_id_multiple_with_existing
  },
  {
    "mqtt5_operation_bind_packet_id_multiple_with_wrap_around",
    mqtt5_operation_bind_packet_id_multiple_with_wrap_around
  },
  {
    "mqtt5_operation_bind_packet_id_full_table",
    mqtt5_operation_bind_packet_id_full_table
  },
  {
    "mqtt5_operation_bind_packet_id_not_valid",
    mqtt5_operation_bind_packet_id_not_valid
  },
  {
    "mqtt5_operation_bind_packet_id_already_bound",
    mqtt5_operation_bind_packet_id_already_bound
  },
  {
    "mqtt5_operation_processing_nothing_empty_queue",
    mqtt5_operation_processing_nothing_empty_queue
  },
  {
    "mqtt5_operation_processing_nothing_mqtt_connect",
    mqtt5_operation_processing_nothing_mqtt_connect
  },
  {
    "mqtt5_operation_processing_nothing_clean_disconnect",
    mqtt5_operation_processing_nothing_clean_disconnect
  },
  {
    "mqtt5_operation_processing_nothing_pending_write_completion_mqtt_connect",
    mqtt5_operation_processing_nothing_pending_write_completion_mqtt_connect
  },
  {
    "mqtt5_operation_processing_nothing_pending_write_completion_connected",
    mqtt5_operation_processing_nothing_pending_write_completion_connected
  },
  {
    "mqtt5_operation_processing_nothing_pending_write_completion_clean_disconnect",
    mqtt5_operation_processing_nothing_pending_write_completion_clean_disconnect
  },
  {
    "mqtt5_operation_processing_failure_message_allocation",
    mqtt5_operation_processing_failure_message_allocation
  },
  {
    "mqtt5_operation_processing_failure_message_send",
    mqtt5_operation_processing_failure_message_send
  },
  {
    "mqtt5_operation_processing_something_mqtt_connect",
    mqtt5_operation_processing_something_mqtt_connect
  },
  {
    "mqtt5_operation_processing_something_clean_disconnect",
    mqtt5_operation_processing_something_clean_disconnect
  },
  {
    "mqtt5_operation_processing_something_connected_multi",
    mqtt5_operation_processing_something_connected_multi
  },
  {
    "mqtt5_operation_processing_something_connected_overflow",
    mqtt5_operation_processing_something_connected_overflow
  },
  {
    "mqtt5_operation_processing_disconnect_fail_all",
    mqtt5_operation_processing_disconnect_fail_all
  },
  {
    "mqtt5_operation_processing_disconnect_fail_qos0",
    mqtt5_operation_processing_disconnect_fail_qos0
  },
  {
    "mqtt5_operation_processing_disconnect_fail_non_qos1",
    mqtt5_operation_processing_disconnect_fail_non_qos1
  },
  {
    "mqtt5_operation_processing_reconnect_rejoin_session_fail_all",
    mqtt5_operation_processing_reconnect_rejoin_session_fail_all
  },
  {
    "mqtt5_operation_processing_reconnect_rejoin_session_fail_qos0",
    mqtt5_operation_processing_reconnect_rejoin_session_fail_qos0
  },
  {
    "mqtt5_operation_processing_reconnect_no_session_fail_all",
    mqtt5_operation_processing_reconnect_no_session_fail_all
  },
  {
    "mqtt5_operation_processing_reconnect_no_session_fail_qos0",
    mqtt5_operation_processing_reconnect_no_session_fail_qos0
  },
  {
    "mqtt5_operation_processing_reconnect_no_session_fail_non_qos1",
    mqtt5_operation_processing_reconnect_no_session_fail_non_qos1
  },
  {
    "mqtt5_negotiated_settings_reset_test",
    mqtt5_negotiated_settings_reset_test
  },
  {
    "mqtt5_negotiated_settings_apply_connack_test",
    mqtt5_negotiated_settings_apply_connack_test
  },
  {
    "mqtt5_negotiated_settings_server_override_test",
    mqtt5_negotiated_settings_server_override_test
  },
  {
    "mqtt5_vli_size",
    mqtt5_vli_size
  },
  {
    "mqtt5_vli_success_round_trip",
    mqtt5_vli_success_round_trip
  },
  {
    "mqtt5_vli_encode_failures",
    mqtt5_vli_encode_failures
  },
  {
    "mqtt5_vli_decode_failures",
    mqtt5_vli_decode_failures
  },
  {
    "mqtt5_packet_disconnect_round_trip",
    mqtt5_packet_disconnect_round_trip
  },
  {
    "mqtt5_packet_pingreq_round_trip",
    mqtt5_packet_pingreq_round_trip
  },
  {
    "mqtt5_packet_pingresp_round_trip",
    mqtt5_packet_pingresp_round_trip
  },
  {
    "mqtt5_packet_connect_round_trip",
    mqtt5_packet_connect_round_trip
  },
  {
    "mqtt5_packet_connack_round_trip",
    mqtt5_packet_connack_round_trip
  },
  {
    "mqtt5_packet_subscribe_round_trip",
    mqtt5_packet_subscribe_round_trip
  },
  {
    "mqtt5_packet_suback_round_trip",
    mqtt5_packet_suback_round_trip
  },
  {
    "mqtt5_packet_unsubscribe_round_trip",
    mqtt5_packet_unsubscribe_round_trip
  },
  {
    "mqtt5_packet_unsuback_round_trip",
    mqtt5_packet_unsuback_round_trip
  },
  {
    "mqtt5_packet_publish_round_trip",
    mqtt5_packet_publish_round_trip
  },
  {
    "mqtt5_packet_puback_round_trip",
    mqtt5_packet_puback_round_trip
  },
  {
    "mqtt5_packet_encode_connect_no_will",
    mqtt5_packet_encode_connect_no_will
  },
  {
    "mqtt5_packet_encode_connect_no_username",
    mqtt5_packet_encode_connect_no_username
  },
  {
    "mqtt5_packet_encode_connect_no_password",
    mqtt5_packet_encode_connect_no_password
  },
  {
    "mqtt5_packet_encode_connect_will_property_order",
    mqtt5_packet_encode_connect_will_property_order
  },
  {
    "mqtt5_first_byte_reserved_header_check_subscribe",
    mqtt5_first_byte_reserved_header_check_subscribe
  },
  {
    "mqtt5_first_byte_reserved_header_check_unsubscribe",
    mqtt5_first_byte_reserved_header_check_unsubscribe
  },
  {
    "mqtt5_first_byte_reserved_header_check_disconnect",
    mqtt5_first_byte_reserved_header_check_disconnect
  },
  {
    "mqtt5_client_direct_connect_success",
    mqtt5_client_direct_connect_success
  },
  {
    "mqtt5_client_direct_connect_sync_channel_failure",
    mqtt5_client_direct_connect_sync_channel_failure
  },
  {
    "mqtt5_client_direct_connect_async_channel_failure",
    mqtt5_client_direct_connect_async_channel_failure
  },
  {
    "mqtt5_client_websocket_connect_sync_channel_failure",
    mqtt5_client_websocket_connect_sync_channel_failure
  },
  {
    "mqtt5_client_websocket_connect_async_channel_failure",
    mqtt5_client_websocket_connect_async_channel_failure
  },
  {
    "mqtt5_client_websocket_connect_handshake_failure",
    mqtt5_client_websocket_connect_handshake_failure
  },
  {
    "mqtt5_client_direct_connect_connack_refusal",
    mqtt5_client_direct_connect_connack_refusal
  },
  {
    "mqtt5_client_direct_connect_connack_timeout",
    mqtt5_client_direct_connect_connack_timeout
  },
  {
    "mqtt5_client_direct_connect_from_server_disconnect",
    mqtt5_client_direct_connect_from_server_disconnect
  },
  {
    "mqtt5_client_subscribe_success",
    mqtt5_client_subscribe_success
  },
  {
    "mqtt5_client_unsubscribe_success",
    mqtt5_client_unsubscribe_success
  },
  {
    "mqtt5_client_sub_pub_unsub_qos0",
    mqtt5_client_sub_pub_unsub_qos0
  },
  {
    "mqtt5_client_sub_pub_unsub_qos1",
    mqtt5_client_sub_pub_unsub_qos1
  },
  {
    "mqtt5_client_ping_sequence",
    mqtt5_client_ping_sequence
  },
  {
    "mqtt5_client_ping_timeout",
    mqtt5_client_ping_timeout
  },
  {
    "mqtt5_client_ping_timeout_with_keep_alive_conflict",
    mqtt5_client_ping_timeout_with_keep_alive_conflict
  },
  {
    "mqtt5_client_disabled_keep_alive",
    mqtt5_client_disabled_keep_alive
  },
  {
    "mqtt5_client_reconnect_failure_backoff",
    mqtt5_client_reconnect_failure_backoff
  },
  {
    "mqtt5_client_reconnect_backoff_insufficient_reset",
    mqtt5_client_reconnect_backoff_insufficient_reset
  },
  {
    "mqtt5_client_reconnect_backoff_sufficient_reset",
    mqtt5_client_reconnect_backoff_sufficient_reset
  },
  {
    "mqtt5_client_subscribe_fail_packet_too_big",
    mqtt5_client_subscribe_fail_packet_too_big
  },
  {
    "mqtt5_client_disconnect_fail_packet_too_big",
    mqtt5_client_disconnect_fail_packet_too_big
  },
  {
    "mqtt5_client_flow_control_receive_maximum",
    mqtt5_client_flow_control_receive_maximum
  },
  {
    "mqtt5_client_publish_timeout",
    mqtt5_client_publish_timeout
  },
  {
    "mqtt5_client_dynamic_operation_timeout",
    mqtt5_client_dynamic_operation_timeout
  },
  {
    "mqtt5_client_dynamic_operation_timeout_default",
    mqtt5_client_dynamic_operation_timeout_default
  },
  {
    "mqtt5_client_flow_control_iot_core_throughput",
    mqtt5_client_flow_control_iot_core_throughput
  },
  {
    "mqtt5_client_flow_control_iot_core_publish_tps",
    mqtt5_client_flow_control_iot_core_publish_tps
  },
  {
    "mqtt5_client_session_resumption_clean_start",
    mqtt5_client_session_resumption_clean_start
  },
  {
    "mqtt5_client_session_resumption_post_success",
    mqtt5_client_session_resumption_post_success
  },
  {
    "mqtt5_client_session_resumption_always",
    mqtt5_client_session_resumption_always
  },
  {
    "mqtt5_client_receive_qos1_return_puback_test",
    mqtt5_client_receive_qos1_return_puback_test
  },
  {
    "mqtt5_client_receive_nonexisting_session_state",
    mqtt5_client_receive_nonexisting_session_state
  },
  {
    "mqtt5_client_receive_assigned_client_id",
    mqtt5_client_receive_assigned_client_id
  },
  {
    "mqtt5_client_no_session_after_client_stop",
    mqtt5_client_no_session_after_client_stop
  },
  {
    "mqtt5_client_restore_session_on_ping_timeout_reconnect",
    mqtt5_client_restore_session_on_ping_timeout_reconnect
  },
  {
    "mqtt5_client_discard_session_on_server_clean_start",
    mqtt5_client_discard_session_on_server_clean_start
  },
  {
    "mqtt5_client_statistics_subscribe",
    mqtt5_client_statistics_subscribe
  },
  {
    "mqtt5_client_statistics_unsubscribe",
    mqtt5_client_statistics_unsubscribe
  },
  {
    "mqtt5_client_statistics_publish_qos0",
    mqtt5_client_statistics_publish_qos0
  },
  {
    "mqtt5_client_statistics_publish_qos1",
    mqtt5_client_statistics_publish_qos1
  },
  {
    "mqtt5_client_statistics_publish_qos1_requeue",
    mqtt5_client_statistics_publish_qos1_requeue
  },
  {
    "mqtt5_client_puback_ordering",
    mqtt5_client_puback_ordering
  },
  {
    "mqtt5_client_listeners",
    mqtt5_client_listeners
  },
  {
    "mqtt5_client_offline_operation_submission_fail_all",
    mqtt5_client_offline_operation_submission_fail_all
  },
  {
    "mqtt5_client_offline_operation_submission_fail_qos0",
    mqtt5_client_offline_operation_submission_fail_qos0
  },
  {
    "mqtt5_client_offline_operation_submission_fail_non_qos1",
    mqtt5_client_offline_operation_submission_fail_non_qos1
  },
  {
    "mqtt5_client_offline_operation_submission_then_connect",
    mqtt5_client_offline_operation_submission_then_connect
  },
  {
    "mqtt5_client_inbound_alias_success",
    mqtt5_client_inbound_alias_success
  },
  {
    "mqtt5_client_inbound_alias_failure_disabled",
    mqtt5_client_inbound_alias_failure_disabled
  },
  {
    "mqtt5_client_inbound_alias_failure_zero_id",
    mqtt5_client_inbound_alias_failure_zero_id
  },
  {
    "mqtt5_client_inbound_alias_failure_too_large_id",
    mqtt5_client_inbound_alias_failure_too_large_id
  },
  {
    "mqtt5_client_inbound_alias_failure_unbound_id",
    mqtt5_client_inbound_alias_failure_unbound_id
  },
  {
    "mqtt5_client_outbound_alias_manual_failure_empty_topic",
    mqtt5_client_outbound_alias_manual_failure_empty_topic
  },
  {
    "mqtt5_client_outbound_alias_manual_success_a_b_ar_br",
    mqtt5_client_outbound_alias_manual_success_a_b_ar_br
  },
  {
    "mqtt5_client_outbound_alias_lru_success_a_b_c_br_cr_a",
    mqtt5_client_outbound_alias_lru_success_a_b_c_br_cr_a
  },
  {
    "rate_limiter_token_bucket_init_invalid",
    rate_limiter_token_bucket_init_invalid
  },
  {
    "rate_limiter_token_bucket_regeneration_integral",
    rate_limiter_token_bucket_regeneration_integral
  },
  {
    "rate_limiter_token_bucket_regeneration_fractional",
    rate_limiter_token_bucket_regeneration_fractional
  },
  {
    "rate_limiter_token_bucket_fractional_iteration",
    rate_limiter_token_bucket_fractional_iteration
  },
  {
    "rate_limiter_token_bucket_large_fractional_iteration",
    rate_limiter_token_bucket_large_fractional_iteration
  },
  {
    "rate_limiter_token_bucket_real_iteration",
    rate_limiter_token_bucket_real_iteration
  },
  {
    "rate_limiter_token_bucket_reset",
    rate_limiter_token_bucket_reset
  },
  {
    "mqtt5to3_adapter_create_destroy",
    mqtt5to3_adapter_create_destroy
  },
  {
    "mqtt5to3_adapter_create_destroy_delayed",
    mqtt5to3_adapter_create_destroy_delayed
  },
  {
    "mqtt5to3_adapter_set_will",
    mqtt5to3_adapter_set_will
  },
  {
    "mqtt5to3_adapter_set_login",
    mqtt5to3_adapter_set_login
  },
  {
    "mqtt5to3_adapter_set_reconnect_timeout",
    mqtt5to3_adapter_set_reconnect_timeout
  },
  {
    "mqtt5to3_adapter_connect_success",
    mqtt5to3_adapter_connect_success
  },
  {
    "mqtt5to3_adapter_connect_success_disconnect_success",
    mqtt5to3_adapter_connect_success_disconnect_success
  },
  {
    "mqtt5to3_adapter_connect_success_disconnect_success_thrice",
    mqtt5to3_adapter_connect_success_disconnect_success_thrice
  },
  {
    "mqtt5to3_adapter_connect_success_connect_failure",
    mqtt5to3_adapter_connect_success_connect_failure
  },
  {
    "mqtt5to3_adapter_connect_success_sloppy_shutdown",
    mqtt5to3_adapter_connect_success_sloppy_shutdown
  },
  {
    "mqtt5to3_adapter_connect_bad_connectivity",
    mqtt5to3_adapter_connect_bad_connectivity
  },
  {
    "mqtt5to3_adapter_connect_bad_connectivity_with_mqtt5_restart",
    mqtt5to3_adapter_connect_bad_connectivity_with_mqtt5_restart
  },
  {
    "mqtt5to3_adapter_connect_failure_connect_success_via_mqtt5",
    mqtt5to3_adapter_connect_failure_connect_success_via_mqtt5
  },
  {
    "mqtt5to3_adapter_connect_failure_bad_config_success_good_config",
    mqtt5to3_adapter_connect_failure_bad_config_success_good_config
  },
  {
    "mqtt5to3_adapter_connect_reconnect_failures",
    mqtt5to3_adapter_connect_reconnect_failures
  },
  {
    "mqtt5to3_adapter_connect_success_disconnect_connect",
    mqtt5to3_adapter_connect_success_disconnect_connect
  },
  {
    "mqtt5to3_adapter_connect_success_stop_mqtt5_disconnect_success",
    mqtt5to3_adapter_connect_success_stop_mqtt5_disconnect_success
  },
  {
    "mqtt5to3_adapter_disconnect_success",
    mqtt5to3_adapter_disconnect_success
  },
  {
    "mqtt5to3_adapter_connect_success_disconnect_success_disconnect_success",
    mqtt5to3_adapter_connect_success_disconnect_success_disconnect_success
  },
  {
    "mqtt5to3_adapter_operation_allocation_simple",
    mqtt5to3_adapter_operation_allocation_simple
  },
  {
    "mqtt5to3_adapter_operation_allocation_wraparound",
    mqtt5to3_adapter_operation_allocation_wraparound
  },
  {
    "mqtt5to3_adapter_operation_allocation_exhaustion",
    mqtt5to3_adapter_operation_allocation_exhaustion
  },
  {
    "mqtt5to3_adapter_publish_failure_invalid",
    mqtt5to3_adapter_publish_failure_invalid
  },
  {
    "mqtt5to3_adapter_publish_failure_offline_queue_policy",
    mqtt5to3_adapter_publish_failure_offline_queue_policy
  },
  {
    "mqtt5to3_adapter_publish_success_qos0",
    mqtt5to3_adapter_publish_success_qos0
  },
  {
    "mqtt5to3_adapter_publish_success_qos1",
    mqtt5to3_adapter_publish_success_qos1
  },
  {
    "mqtt5to3_adapter_publish_qos1_fail_ack",
    mqtt5to3_adapter_publish_qos1_fail_ack
  },
  {
    "mqtt5to3_adapter_publish_no_ack",
    mqtt5to3_adapter_publish_no_ack
  },
  {
    "mqtt5to3_adapter_publish_interrupted",
    mqtt5to3_adapter_publish_interrupted
  },
  {
    "mqtt5to3_adapter_subscribe_single_success",
    mqtt5to3_adapter_subscribe_single_success
  },
  {
    "mqtt5to3_adapter_subscribe_multi_success",
    mqtt5to3_adapter_subscribe_multi_success
  },
  {
    "mqtt5to3_adapter_subscribe_single_failure",
    mqtt5to3_adapter_subscribe_single_failure
  },
  {
    "mqtt5to3_adapter_subscribe_single_invalid",
    mqtt5to3_adapter_subscribe_single_invalid
  },
  {
    "mqtt5to3_adapter_subscribe_multi_failure",
    mqtt5to3_adapter_subscribe_multi_failure
  },
  {
    "mqtt5to3_adapter_subscribe_multi_invalid",
    mqtt5to3_adapter_subscribe_multi_invalid
  },
  {
    "mqtt5to3_adapter_subscribe_single_publish",
    mqtt5to3_adapter_subscribe_single_publish
  },
  {
    "mqtt5to3_adapter_subscribe_multi_overlapping_publish",
    mqtt5to3_adapter_subscribe_multi_overlapping_publish
  },
  {
    "mqtt5to3_adapter_unsubscribe_success",
    mqtt5to3_adapter_unsubscribe_success
  },
  {
    "mqtt5to3_adapter_unsubscribe_failure",
    mqtt5to3_adapter_unsubscribe_failure
  },
  {
    "mqtt5to3_adapter_unsubscribe_invalid",
    mqtt5to3_adapter_unsubscribe_invalid
  },
  {
    "mqtt5to3_adapter_unsubscribe_overlapped",
    mqtt5to3_adapter_unsubscribe_overlapped
  },
  {
    "mqtt5to3_adapter_get_stats",
    mqtt5to3_adapter_get_stats
  },
  {
    "mqtt5to3_adapter_resubscribe_nothing",
    mqtt5to3_adapter_resubscribe_nothing
  },
  {
    "mqtt5to3_adapter_resubscribe_something",
    mqtt5to3_adapter_resubscribe_something
  },
  {
    "mqtt5to3_adapter_subscribe_single_null_suback",
    mqtt5to3_adapter_subscribe_single_null_suback
  },
  {
    "mqtt5to3_adapter_subscribe_multi_null_suback",
    mqtt5to3_adapter_subscribe_multi_null_suback
  },
  {
    "mqtt5to3_adapter_operation_callbacks_after_shutdown",
    mqtt5to3_adapter_operation_callbacks_after_shutdown
  },
  {
    "mqtt_subscription_set_add_empty_not_subbed",
    mqtt_subscription_set_add_empty_not_subbed
  },
  {
    "mqtt_subscription_set_add_single_path",
    mqtt_subscription_set_add_single_path
  },
  {
    "mqtt_subscription_set_add_overlapped_branching_paths",
    mqtt_subscription_set_add_overlapped_branching_paths
  },
  {
    "mqtt_subscription_set_remove_overlapping_path",
    mqtt_subscription_set_remove_overlapping_path
  },
  {
    "mqtt_subscription_set_remove_branching_path",
    mqtt_subscription_set_remove_branching_path
  },
  {
    "mqtt_subscription_set_remove_invalid",
    mqtt_subscription_set_remove_invalid
  },
  {
    "mqtt_subscription_set_remove_empty_segments",
    mqtt_subscription_set_remove_empty_segments
  },
  {
    "mqtt_subscription_set_add_remove_repeated",
    mqtt_subscription_set_add_remove_repeated
  },
  {
    "mqtt_subscription_set_publish_single_path",
    mqtt_subscription_set_publish_single_path
  },
  {
    "mqtt_subscription_set_publish_multi_path",
    mqtt_subscription_set_publish_multi_path
  },
  {
    "mqtt_subscription_set_publish_single_level_wildcards",
    mqtt_subscription_set_publish_single_level_wildcards
  },
  {
    "mqtt_subscription_set_publish_multi_level_wildcards",
    mqtt_subscription_set_publish_multi_level_wildcards
  },
  {
    "mqtt_subscription_set_get_subscriptions",
    mqtt_subscription_set_get_subscriptions
  },
  {
    "request_response_mqtt5_protocol_adapter_subscribe_success",
    request_response_mqtt5_protocol_adapter_subscribe_success
  },
  {
    "request_response_mqtt5_protocol_adapter_subscribe_failure_error_code",
    request_response_mqtt5_protocol_adapter_subscribe_failure_error_code
  },
  {
    "request_response_mqtt5_protocol_adapter_subscribe_failure_reason_code",
    request_response_mqtt5_protocol_adapter_subscribe_failure_reason_code
  },
  {
    "request_response_mqtt5_protocol_adapter_subscribe_failure_timeout",
    request_response_mqtt5_protocol_adapter_subscribe_failure_timeout
  },
  {
    "request_response_mqtt5_protocol_adapter_unsubscribe_success",
    request_response_mqtt5_protocol_adapter_unsubscribe_success
  },
  {
    "request_response_mqtt5_protocol_adapter_unsubscribe_failure_error_code",
    request_response_mqtt5_protocol_adapter_unsubscribe_failure_error_code
  },
  {
    "request_response_mqtt5_protocol_adapter_unsubscribe_failure_reason_code_retryable",
    request_response_mqtt5_protocol_adapter_unsubscribe_failure_reason_code_retryable
  },
  {
    "request_response_mqtt5_protocol_adapter_unsubscribe_failure_reason_code_not_retryable",
    request_response_mqtt5_protocol_adapter_unsubscribe_failure_reason_code_not_retryable
  },
  {
    "request_response_mqtt5_protocol_adapter_unsubscribe_failure_timeout",
    request_response_mqtt5_protocol_adapter_unsubscribe_failure_timeout
  },
  {
    "request_response_mqtt5_protocol_adapter_publish_success",
    request_response_mqtt5_protocol_adapter_publish_success
  },
  {
    "request_response_mqtt5_protocol_adapter_publish_failure_error_code",
    request_response_mqtt5_protocol_adapter_publish_failure_error_code
  },
  {
    "request_response_mqtt5_protocol_adapter_publish_failure_reason_code",
    request_response_mqtt5_protocol_adapter_publish_failure_reason_code
  },
  {
    "request_response_mqtt5_protocol_adapter_publish_failure_timeout",
    request_response_mqtt5_protocol_adapter_publish_failure_timeout
  },
  {
    "request_response_mqtt5_protocol_adapter_connection_event_connect_no_session",
    request_response_mqtt5_protocol_adapter_connection_event_connect_no_session
  },
  {
    "request_response_mqtt5_protocol_adapter_connection_event_connect_session",
    request_response_mqtt5_protocol_adapter_connection_event_connect_session
  },
  {
    "request_response_mqtt5_protocol_adapter_incoming_publish",
    request_response_mqtt5_protocol_adapter_incoming_publish
  },
  {
    "request_response_mqtt5_protocol_adapter_shutdown_while_pending",
    request_response_mqtt5_protocol_adapter_shutdown_while_pending
  },
  {
    "request_response_mqtt311_protocol_adapter_subscribe_success",
    request_response_mqtt311_protocol_adapter_subscribe_success
  },
  {
    "request_response_mqtt311_protocol_adapter_subscribe_failure_timeout",
    request_response_mqtt311_protocol_adapter_subscribe_failure_timeout
  },
  {
    "request_response_mqtt311_protocol_adapter_subscribe_failure_reason_code",
    request_response_mqtt311_protocol_adapter_subscribe_failure_reason_code
  },
  {
    "request_response_mqtt311_protocol_adapter_unsubscribe_success",
    request_response_mqtt311_protocol_adapter_unsubscribe_success
  },
  {
    "request_response_mqtt311_protocol_adapter_unsubscribe_failure_timeout",
    request_response_mqtt311_protocol_adapter_unsubscribe_failure_timeout
  },
  {
    "request_response_mqtt311_protocol_adapter_publish_success",
    request_response_mqtt311_protocol_adapter_publish_success
  },
  {
    "request_response_mqtt311_protocol_adapter_publish_failure_timeout",
    request_response_mqtt311_protocol_adapter_publish_failure_timeout
  },
  {
    "request_response_mqtt311_protocol_adapter_connection_events",
    request_response_mqtt311_protocol_adapter_connection_events
  },
  {
    "request_response_mqtt311_protocol_adapter_incoming_publish",
    request_response_mqtt311_protocol_adapter_incoming_publish
  },
  {
    "request_response_mqtt311_protocol_adapter_shutdown_while_pending",
    request_response_mqtt311_protocol_adapter_shutdown_while_pending
  },
  {
    "mqtt311_listener_connection_events_no_session",
    mqtt311_listener_connection_events_no_session
  },
  {
    "mqtt311_listener_connection_events_with_session",
    mqtt311_listener_connection_events_with_session
  },
  {
    "mqtt311_listener_publish_event",
    mqtt311_listener_publish_event
  },
  {
    "rrsm_acquire_subscribing",
    rrsm_acquire_subscribing
  },
  {
    "rrsm_acquire_multi_subscribing",
    rrsm_acquire_multi_subscribing
  },
  {
    "rrsm_acquire_existing_subscribing",
    rrsm_acquire_existing_subscribing
  },
  {
    "rrsm_acquire_multi_existing_subscribing",
    rrsm_acquire_multi_existing_subscribing
  },
  {
    "rrsm_acquire_multi_partially_subscribed",
    rrsm_acquire_multi_partially_subscribed
  },
  {
    "rrsm_acquire_existing_subscribed",
    rrsm_acquire_existing_subscribed
  },
  {
    "rrsm_acquire_multi_existing_subscribed",
    rrsm_acquire_multi_existing_subscribed
  },
  {
    "rrsm_acquire_blocked_rr",
    rrsm_acquire_blocked_rr
  },
  {
    "rrsm_acquire_multi_blocked_rr",
    rrsm_acquire_multi_blocked_rr
  },
  {
    "rrsm_acquire_blocked_eventstream",
    rrsm_acquire_blocked_eventstream
  },
  {
    "rrsm_acquire_multi_blocked_eventstream",
    rrsm_acquire_multi_blocked_eventstream
  },
  {
    "rrsm_acquire_no_capacity_max1",
    rrsm_acquire_no_capacity_max1
  },
  {
    "rrsm_acquire_no_capacity_too_many_event_stream",
    rrsm_acquire_no_capacity_too_many_event_stream
  },
  {
    "rrsm_acquire_multi_no_capacity_event_stream",
    rrsm_acquire_multi_no_capacity_event_stream
  },
  {
    "rrsm_acquire_failure_mixed_subscription_types",
    rrsm_acquire_failure_mixed_subscription_types
  },
  {
    "rrsm_acquire_multi_failure_mixed_subscription_types",
    rrsm_acquire_multi_failure_mixed_subscription_types
  },
  {
    "rrsm_acquire_failure_poisoned",
    rrsm_acquire_failure_poisoned
  },
  {
    "rrsm_release_unsubscribes_request",
    rrsm_release_unsubscribes_request
  },
  {
    "rrsm_release_unsubscribes_streaming",
    rrsm_release_unsubscribes_streaming
  },
  {
    "rrsm_release_multi_unsubscribes_request",
    rrsm_release_multi_unsubscribes_request
  },
  {
    "rrsm_release_unsubscribe_success_clears_space",
    rrsm_release_unsubscribe_success_clears_space
  },
  {
    "rrsm_release_unsubscribe_failure_blocked",
    rrsm_release_unsubscribe_failure_blocked
  },
  {
    "rrsm_acquire_failure_subscribe_sync_failure_request",
    rrsm_acquire_failure_subscribe_sync_failure_request
  },
  {
    "rrsm_acquire_failure_subscribe_sync_failure_streaming",
    rrsm_acquire_failure_subscribe_sync_failure_streaming
  },
  {
    "rrsm_acquire_request_subscribe_failure_event",
    rrsm_acquire_request_subscribe_failure_event
  },
  {
    "rrsm_acquire_streaming_subscribe_failure_retryable_resubscribe",
    rrsm_acquire_streaming_subscribe_failure_retryable_resubscribe
  },
  {
    "rrsm_offline_acquire_request_online_success",
    rrsm_offline_acquire_request_online_success
  },
  {
    "rrsm_offline_acquire_request_online_failure",
    rrsm_offline_acquire_request_online_failure
  },
  {
    "rrsm_offline_acquire_streaming_online_success",
    rrsm_offline_acquire_streaming_online_success
  },
  {
    "rrsm_offline_acquire_streaming_online_failure",
    rrsm_offline_acquire_streaming_online_failure
  },
  {
    "rrsm_offline_acquire_release_request_online",
    rrsm_offline_acquire_release_request_online
  },
  {
    "rrsm_offline_acquire_release_streaming_online",
    rrsm_offline_acquire_release_streaming_online
  },
  {
    "rrsm_acquire_request_success_offline_release_acquire2_no_unsubscribe",
    rrsm_acquire_request_success_offline_release_acquire2_no_unsubscribe
  },
  {
    "rrsm_acquire_streaming_success_offline_release_acquire2_no_unsubscribe",
    rrsm_acquire_streaming_success_offline_release_acquire2_no_unsubscribe
  },
  {
    "rrsm_acquire_request_success_clean_up_unsubscribe_override",
    rrsm_acquire_request_success_clean_up_unsubscribe_override
  },
  {
    "rrsm_acquire_streaming_success_clean_up_unsubscribe_override",
    rrsm_acquire_streaming_success_clean_up_unsubscribe_override
  },
  {
    "rrsm_acquire_request_pending_clean_up_unsubscribe_override",
    rrsm_acquire_request_pending_clean_up_unsubscribe_override
  },
  {
    "rrsm_acquire_streaming_pending_clean_up_unsubscribe_override",
    rrsm_acquire_streaming_pending_clean_up_unsubscribe_override
  },
  {
    "rrsm_offline_acquire_request_pending_clean_up_unsubscribe_override",
    rrsm_offline_acquire_request_pending_clean_up_unsubscribe_override
  },
  {
    "rrsm_offline_acquire_streaming_pending_clean_up_unsubscribe_override",
    rrsm_offline_acquire_streaming_pending_clean_up_unsubscribe_override
  },
  {
    "rrsm_acquire_request_success_offline_online_no_session_subscription_ended_can_reacquire",
    rrsm_acquire_request_success_offline_online_no_session_subscription_ended_can_reacquire
  },
  {
    "rrsm_request_subscription_ended_while_unsubscribing",
    rrsm_request_subscription_ended_while_unsubscribing
  },
  {
    "rrsm_streaming_subscription_lost_resubscribe_on_no_session",
    rrsm_streaming_subscription_lost_resubscribe_on_no_session
  },
  {
    "rrsm_request_subscription_purge_events",
    rrsm_request_subscription_purge_events
  },
  {
    "rrsm_streaming_subscription_purge_events",
    rrsm_streaming_subscription_purge_events
  },
  {
    "rrc_mqtt5_create_destroy",
    rrc_mqtt5_create_destroy
  },
  {
    "rrc_mqtt311_create_destroy",
    rrc_mqtt311_create_destroy
  },
  {
    "rrc_submit_request_operation_failure_no_response_paths",
    rrc_submit_request_operation_failure_no_response_paths
  },
  {
    "rrc_submit_request_operation_failure_invalid_response_topic",
    rrc_submit_request_operation_failure_invalid_response_topic
  },
  {
    "rrc_submit_request_operation_failure_invalid_publish_topic",
    rrc_submit_request_operation_failure_invalid_publish_topic
  },
  {
    "rrc_submit_request_operation_failure_invalid_subscription_topic_filter",
    rrc_submit_request_operation_failure_invalid_subscription_topic_filter
  },
  {
    "rrc_submit_request_operation_failure_no_subscription_topic_filters",
    rrc_submit_request_operation_failure_no_subscription_topic_filters
  },
  {
    "rrc_submit_request_operation_failure_empty_request",
    rrc_submit_request_operation_failure_empty_request
  },
  {
    "rrc_submit_streaming_operation_failure_invalid_subscription_topic_filter",
    rrc_submit_streaming_operation_failure_invalid_subscription_topic_filter
  },
  {
    "rrc_submit_request_operation_failure_by_shutdown",
    rrc_submit_request_operation_failure_by_shutdown
  },
  {
    "rrc_create_streaming_operation_and_shutdown",
    rrc_create_streaming_operation_and_shutdown
  },
  {
    "rrc_activate_streaming_operation_and_shutdown",
    rrc_activate_streaming_operation_and_shutdown
  },
  {
    "rrc_submit_request_operation_failure_by_timeout",
    rrc_submit_request_operation_failure_by_timeout
  },
  {
    "rrc_streaming_operation_success_single",
    rrc_streaming_operation_success_single
  },
  {
    "rrc_streaming_operation_success_overlapping",
    rrc_streaming_operation_success_overlapping
  },
  {
    "rrc_streaming_operation_success_starting_offline",
    rrc_streaming_operation_success_starting_offline
  },
  {
    "rrc_streaming_operation_clean_session_reestablish_subscription",
    rrc_streaming_operation_clean_session_reestablish_subscription
  },
  {
    "rrc_streaming_operation_resume_session",
    rrc_streaming_operation_resume_session
  },
  {
    "rrc_streaming_operation_first_subscribe_times_out_resub_succeeds",
    rrc_streaming_operation_first_subscribe_times_out_resub_succeeds
  },
  {
    "rrc_streaming_operation_first_subscribe_retryable_failure_resub_succeeds",
    rrc_streaming_operation_first_subscribe_retryable_failure_resub_succeeds
  },
  {
    "rrc_streaming_operation_subscribe_unretryable_failure",
    rrc_streaming_operation_subscribe_unretryable_failure
  },
  {
    "rrc_streaming_operation_failure_exceeds_subscription_budget",
    rrc_streaming_operation_failure_exceeds_subscription_budget
  },
  {
    "rrc_streaming_operation_success_delayed_by_request_operations",
    rrc_streaming_operation_success_delayed_by_request_operations
  },
  {
    "rrc_streaming_operation_success_sandwiched_by_request_operations",
    rrc_streaming_operation_success_sandwiched_by_request_operations
  },
  {
    "rrc_request_response_success_response_path_accepted",
    rrc_request_response_success_response_path_accepted
  },
  {
    "rrc_request_response_multi_sub_success_response_path_accepted",
    rrc_request_response_multi_sub_success_response_path_accepted
  },
  {
    "rrc_request_response_success_response_path_rejected",
    rrc_request_response_success_response_path_rejected
  },
  {
    "rrc_request_response_multi_sub_success_response_path_rejected",
    rrc_request_response_multi_sub_success_response_path_rejected
  },
  {
    "rrc_request_response_success_empty_correlation_token",
    rrc_request_response_success_empty_correlation_token
  },
  {
    "rrc_request_response_success_empty_correlation_token_sequence",
    rrc_request_response_success_empty_correlation_token_sequence
  },
  {
    "rrc_request_response_subscribe_failure",
    rrc_request_response_subscribe_failure
  },
  {
    "rrc_request_response_multi_subscribe_failure",
    rrc_request_response_multi_subscribe_failure
  },
  {
    "rrc_request_response_failure_puback_reason_code",
    rrc_request_response_failure_puback_reason_code
  },
  {
    "rrc_request_response_failure_invalid_payload",
    rrc_request_response_failure_invalid_payload
  },
  {
    "rrc_request_response_failure_missing_correlation_token",
    rrc_request_response_failure_missing_correlation_token
  },
  {
    "rrc_request_response_failure_invalid_correlation_token_type",
    rrc_request_response_failure_invalid_correlation_token_type
  },
  {
    "rrc_request_response_failure_non_matching_correlation_token",
    rrc_request_response_failure_non_matching_correlation_token
  },
  {
    "rrc_request_response_multi_operation_sequence",
    rrc_request_response_multi_operation_sequence
  },

  { CM_NULL, CM_NULL } /* NOLINT */
};

CM_LOCAL const int NumTests = CM_CAST(int,
  sizeof(cmakeGeneratedFunctionMapEntries) / sizeof(functionMapEntry)) - 1;

/* Allocate and create a lowercased copy of string
   (note that it has to be free'd manually) */
CM_LOCAL char* lowercase(const char* string)
{
  char *new_string;
  char *p;
  size_t stringSize;

  stringSize = CM_CAST(size_t, strlen(string) + 1);
  new_string = CM_CAST(char*, malloc(sizeof(char) * stringSize));

  if (new_string == CM_NULL) { /* NOLINT */
    return CM_NULL;            /* NOLINT */
  }
  strcpy(new_string, string);  /* NOLINT */
  for (p = new_string; *p != 0; ++p) {
    *p = CM_CAST(char, tolower(*p));
  }
  return new_string;
}

CM_LOCAL int isTestSkipped(const char *name, int n_skipped_tests, char *skipped_tests[]) {
  int i;
  for (i = 0; i < n_skipped_tests; i++) {
    if (strcmp(name, skipped_tests[i]) == 0) {
      return 1;
    }
  }

  return 0;
}

CM_NAMESPACE_END

int main(int ac, char* av[])
{
  int i;
  int testNum = 0;
  int partial_match;
  int run_all;
  char *arg;
  int testToRun = -1;

  

  /* If no test name was given */
  /* process command line with user function.  */
  if (ac < 2) {
    /* Ask for a test.  */
    printf("Available tests:\n");
    for (i = 0; i < NumTests; ++i) {
      printf("%3d. %s\n", i, cmakeGeneratedFunctionMapEntries[i].name);
    }
    printf("To run a test, enter the test number: ");
    fflush(stdout);
    if (scanf("%d", &testNum) != 1) {
      printf("Couldn't parse that input as a number\n");
      return -1;
    }
    if (testNum >= NumTests) {
      printf("%3d is an invalid test number.\n", testNum);
      return -1;
    }
    testToRun = testNum;
    ac--;
    av++;
  }
  partial_match = 0;
  run_all = 0;
  arg = CM_NULL; /* NOLINT */
  /* If partial match or running all tests are requested.  */
  if (testToRun == -1 && ac > 1) {
    partial_match = (strcmp(av[1], "-R") == 0) ? 1 : 0;
    run_all = (strcmp(av[1], "-A") == 0) ? 1 : 0;
  }
  if (partial_match != 0 && ac < 3) {
    printf("-R needs an additional parameter.\n");
    return -1;
  }
  if (run_all == 1) {
    clock_t t;
    int status = 0;
    const char* status_message = CM_NULL;
    printf("TAP version 13\n");
    printf("1..%d\n", NumTests);
    for (i = 0; i < NumTests; ++i) {
      const char *name = cmakeGeneratedFunctionMapEntries[i].name;
      if (ac > 2) {
        if (isTestSkipped(name, ac - 2, av + 2) == 1) {
          printf("ok %d %s # SKIP\n", i + 1, name);
          continue;
        }
      }
      t = clock();
      status = (*cmakeGeneratedFunctionMapEntries[i].func)(ac, av);
      t = clock() - t;
      status_message = (status == -1) ? "not ok" : "ok";
      {
        double time_taken = CM_CAST(double, t) / CLOCKS_PER_SEC;
        printf("%s %d %s # %f\n", status_message, i + 1, name, time_taken);
      }
    }
    printf("All tests finished.\n");

    return 0;
  }

  if (testToRun == -1) {
    arg = lowercase(av[1 + partial_match]);
  }
  for (i = 0; i < NumTests && testToRun == -1; ++i) {
    char *test_name = lowercase(cmakeGeneratedFunctionMapEntries[i].name);
    if (partial_match != 0 && strstr(test_name, arg) != CM_NULL) { /* NOLINT */
      testToRun = i;
      ac -= 2;
      av += 2;
    } else if (partial_match == 0 && strcmp(test_name, arg) == 0) {
      testToRun = i;
      ac--;
      av++;
    }
    free(test_name);
  }
  free(arg);
  if (testToRun != -1) {
    int result;

    if (testToRun < 0 || testToRun >= NumTests) {
      printf("testToRun was modified by TestDriver code to an invalid value: "
             "%3d.\n",
             testNum);
      return -1;
    }
    result = (*cmakeGeneratedFunctionMapEntries[testToRun].func)(ac, av);

    return result;
  }

  /* Nothing was run, display the test names.  */
  printf("Available tests:\n");
  for (i = 0; i < NumTests; ++i) {
    printf("%3d. %s\n", i, cmakeGeneratedFunctionMapEntries[i].name);
  }
  printf("Failed: %s is an invalid test name.\n", av[1]);

  return -1;
}
